      program cf_panel1
c
c     Program for calculating the dispersion curve 
c     and plotting it on the c(phase velocity)-frequency_panel 
c
c     2018.10.19 Major Revision
c
      parameter(nmax=2048,nrad=20,ma0=400,nfile0=5,mmax=4000)
      real fr(nmax),cr(nmax,nrad),sd(nmax,nrad),r(nrad),cvl(mmax),
     *     rdum(nrad,nfile0),frmi(nrad,nfile0),frma(nrad,nfile0),    
     *     c(nmax,nrad),sd0(nmax,nrad),f_misfit(nmax,mmax),
     *     fq(mmax),std(mmax),xxdm(nrad),cdm(mmax)
      integer mm(nfile0),nf(nrad),n_flg(4)
      character cdrv*10,cwkf*80,com1*50,cform*80
      character filen*80,fname*12,cdummy*19,ccr(nrad)*8
      data pai/3.141592/ big/1.e+12/ vel_min,vel_max/50.,5000./
      data cdrv/'./spacwkf/'/ normalize/0/ eps0/0.1/ smthf/0.05/

c controling flags
      data n_flg/1,0,1,1/
c n_flg(1)=1: Set lower freq. limit for each SPAC coef. curve
c             at the maximum between fmin and 1st zero-cross 
c      (2)=1: Set higher freq. limit for each SPAC coef. curve
c             at the minimum next of 1st zero cross
c      (3)=1: Set the higher freq. limit by spatial Nyquist wavelength
c      (4)=1: Cut the dispersion curve lower than the maximum of
c             determined phase velocity
c
      pi2=pai*2.
      cwkf=cdrv//'prm/'
c reading from the parameter file
      filen=cwkf(1:14)//'cf_panel1.prm'
      open(3,file=filen,status='old')
      read(3,'(a50)')com1        ! used as the title of Graph "cf_panel.plt"
      read(3,*)n_message,n_comparison,nfskip,tdur,aps
      write(6,'(a11,i3,a14,i3,a8,i3,a4,f6.2,a3,e12.3)')
     *   ' n_message=',n_message,' n_comparison=',n_comparison,
     *   ' nfskip=',nfskip,' Td=',tdur,'sec',aps
      read(3,*)fmin,fmax,vmin,vmax
      write(6,'(a25,f8.2,a8,f8.2,a4,a16,f8.2)')
     *  ' Range of Analysis: from ',fmin,'(Hz) to ',fmax,'(Hz)'
      write(6,'(15x,a10,f8.2,a9,f8.2,a5)')
     *  ' and from ',vmin,'(m/s) to ',vmax,'(m/s)'
c range of plotting:fmin0,fmax0,vmin0,vmax0
      fmin0=fmin
      fmax0=fmax
      vmin0=vmin
      vmax0=vmax
c range of analysis:vel_min,vel_max
      vel_min=vmin
      vel_max=vmax
c
      read(3,*)nfile
      write(6,'(a18,i3,a23)')' Number of files= ',nfile,
     *                          ' for SPAC Coef. curves.'
      if(nfile.gt.nfile0) then
       write(6,*)'Too many files. Process Terminated.'
       stop
      endif
c
      fr_1st=nmax
      fr_end=1
      do ifile=1,nfile
       read(3,*)fname  
       read(3,*)mm(ifile)
       do im=1,mm(ifile)
        read(3,*) rdum(im,ifile)
       enddo
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//fname
       open(1,file=filen,status='old')
       read(1,*)                       ! skip 1st line
c frequency
       do i=1,nmax
        read(1,*,err=20,end=20)fr_check
        if(i.eq.1) f_stch=fr_check
       enddo
   20  f_edch=fr_check
       close(1)
       fr_1st=min(fr_1st,f_stch)
       fr_end=max(fr_end,f_edch)
      enddo
      rewind(3)
      do iline=1,4                     ! skip first 4 lines
       read(3,*)
      enddo
c
      dfreq=1./tdur                    ! frequency interval
      nf0=int((fr_end-fr_1st)/dfreq)
c     write(6,*)fr_1st,fr_end,dfreq,nf0
      do i=1,nf0
       fr(i)=fr_1st+dfreq*real(i-1)
      enddo
c cleaning
      do i=1,nmax
       do irad=1,nrad
        cr(i,irad)=0.0
       enddo
      enddo
      do i=1,nmax
       do irad=1,nrad
        sd(i,irad)=0.0
       enddo
      enddo
c     write(6,*)fr(1),fr(nf0),nf0
      nrmax=0
      dmin=big
      nrad_check=0
      do ifile=1,nfile
       read(3,*)fname  
       write(6,'(i2,2x,a12)')ifile,fname
       read(3,*)mm(ifile)
       nrad_check=nrad_check+mm(ifile)
c      write(6,'(a19,i3)')' Number of Radius= ',mm(ifile)
       if(nrad_check.gt.nrad) then
        write(6,*)'Too many radius. Process Terminated.'
        stop
       endif
       do im=1,mm(ifile)
        fmin_d=fmin0
        fmax_d=fmax0
        read(3,'(a20)',end=8) filen  ! as a character string
        read(filen,*,end=3) rdum(im,ifile),fmin_d,fmax_d
        go to 7
    3   read(filen,*,end=4)rdum(im,ifile),fmin_d
        go to 7
    4   read(filen,*)rdum(im,ifile)
    7   continue
        frmi(im,ifile)=max(fmin,fmin_d)
        frma(im,ifile)=min(fmax,fmax_d)
c       write(6,'(f8.3,a8,f8.2,a7,f8.2,a4)')rdum(im,ifile),'(m) from'
c    *      ,fmin_d,'(Hz) to',fmax_d,'(Hz)'
c    *      ,frmi(im,ifile),'(Hz) to',frma(im,ifile),'(Hz)'
       enddo
       goto 9
    8  write(6,*) ' Err. in cf_panel1.prm!'
       stop
    9  continue
c reading from the data files and resampling
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//fname
c       write(6,*)filen
       open(1,file=filen,status='old')
       read(1,'(1x,i6)') nrad1
       backspace(1)
       if(nrad1.lt.10) then
	  write(cdummy,'(a4,i1,a10)')'(8x,',nrad1,'(f7.1,1x))'
       else if(nrad1.ge.10) then
	  write(cdummy,'(a4,i2,a10)')'(8x,',nrad1,'(f7.1,1x))'
       endif
       read(1,cdummy) (r(im+nrmax),im=1,nrad1)
       do im=1,nrad1
        if(dmin.gt.r(im+nrmax)) then
         dmin=r(im+nrmax)
         ifile_dmin=ifile
         im_dmin=im
        endif
       enddo
c SPAC coef. and its SD
       read(1,*,err=60,end=60)fdum
       backspace(1)
       do idum=1,nmax
        if(abs(fdum-fr(idum)).lt.1.e-3) goto 52
       enddo
   52  continue
c      write(6,*) idum,fdum,fr(idum)
       do i=idum,nmax
        read(1,*,err=60,end=60)fdum,(cr(i,irad+nrmax),irad=1,nrad1),
     *                              (sd(i,irad+nrmax),irad=1,nrad1)
        if(nfskip.ne.0) then 
         do iskip=1,nfskip
          read(1,*,end=60)
         enddo
        endif
       enddo
   60  continue
       do irad=1,nrad1
        nf(irad+nrmax)=i-1
       enddo
       close(1)
       do im=1,mm(ifile)
        if(abs(rdum(im,ifile)-r(im+nrmax)).ge.1.e-1) then
         write(6,*)'Err. in list of radius in cf_panel1.prm.'
     *      ,rdum(im,ifile),r(im+nrmax)
         stop
        endif
       enddo
       nrmax=nrmax +nrad1
      enddo
c      nf0=nf(1)
c     write(6,*)'At file#',ifile_dmin,'dist#',im_dmin,
c    *                              'Min. distance =',dmin
c      do irad=1,nrmax
c       if(nf0.lt.nf(irad)) nf0=nf(irad)
c      enddo
      close(3)                                ! cf_panel1.prm closed.
c cr(i,irad):SPAC coef. of irad-th radius at i-th frequency
c sd(i,irad):SD of SPAC coef. of irad-th radius at i-th frequency
c r(irad):irad-th radius
c     write(6,*)fmin,fmax
      ist=1   
      do i=1,nf0
       if(fr(i).gt.fmin) then
        ist=i
c       write(6,*)ist,fr(ist),fmin
        goto 80
       endif 
      enddo
   80 continue
      ied=nf0
      do i=nf0,ist,-1
       if(fr(i).lt.fmax) then
        ied=i
c       write(6,*)ied,fr(ied),fmax
        goto 90
       endif
      enddo
   90 continue
c     write(6,'(2(a5,i5,f8.2))')' ist=',ist,fr(ist),' ied=',ied,fr(ied)
c SD sd() to variance sd0(), of SPAC coefficient
      do i=1,nf0
       do ir=1,nrmax
        sd0(i,ir)=sd(i,ir)**2
       enddo
      enddo
c determination of frmi(im,ifile) and frma(im,ifile) from cr(i,ir), i=1,nn, ir=1,nrmax 
      filen=cwkf(1:23)//'f_range.dat'
      open(15,file=filen,status='unknown')
c     write(6,*)  'Frequency Range of Analysis:'
      write(15,*) 'Frequency Range of Analysis:'
      write(6,'(4a8)')'    No. ','Distance',' min_fr ',' max_fr '
      write(6,'(2x,4a8)')'        ','       m','      Hz','      Hz'
      write(15,'(4a8)')'    No. ','Distance',' min_fr ',' max_fr '
      do ifile=1,nfile 
       do im=1,mm(ifile)
	if(ifile.eq.1) ir=im
	if(ifile.eq.2) ir=im+mm(1)
	if(ifile.eq.3) ir=im+mm(1)+mm(2)
	if(ifile.eq.4) ir=im+mm(1)+mm(2)+mm(3)
	if(ifile.eq.5) ir=im+mm(1)+mm(2)+mm(3)+mm(4)
c search for the first zero-cross of SPAC coefficient
c       write(6,*)im,ifile,frmi(im,ifile),'(Hz) to',
c    *                     frma(im,ifile),'(Hz).'
        do i=1,nf0-1
         if(fr(i).ge.frmi(im,ifile).and.fr(i).le.frma(im,ifile)) then
          if(cr(i,ir).ge.0..and.cr(i+1,ir).le.0.) then
           goto 100
          endif
         endif
        enddo
  100   i_zero=i
c      write(6,*)ifile,im,i_zero,fr(i_zero)
c search 1st maximum from zero-cross toward lower frequency
        i_max=i_zero
        do i=i_zero-1,2,-1
         if(cr(i-1,ir).lt.cr(i,ir)) then
          a_max=cr(i,ir)
          i_max=i
          goto 110
         endif
        enddo
  110   continue
c or search the maximum within the search range [frmi,frma] 
c useful in case of un-expected sag of SPAC coeff. curve 
        i_max=i_zero
        do i=2,nf0-1
         if(fr(i).ge.frmi(im,ifile).and.fr(i).le.frma(im,ifile)) then
          if(cr(i,ir).gt.cr(i_max,ir)) then
           i_max=i
          endif
         endif
        enddo
c control flag #1
        if(n_flg(1).eq.1) then
         if(fr(i_max).gt.frmi(im,ifile)) frmi(im,ifile)=fr(i_max)
c        write(6,*)'Flag#1 on:',ifile,'-th  file,',
c    *             im,'-th distance',frmi(im,ifile),
c    *                                     '(Hz) to',frma(im,ifile)
        endif
c search 1st minimum from zero-cross toward higher frequency
        i_min=i_zero
        do i=i_zero+1,nf0-1
         if(cr(i,ir).lt.cr(i+1,ir)) then
          a_min=cr(i,ir)
          i_min=i
          goto 112
         endif
        enddo
  112   continue
c or search the minimum between zero-cross and frma
c        i_min=i_zero
c        do i=i_zero+1,nf0-1
c         if(fr(i).ge.frmi(im,ifile).and.fr(i).le.frma(im,ifile)) then
c          if(cr(i,ir).lt.cr(i_min,ir)) then
c           i_min=i
c          endif
c         endif
c        enddo
c control flag #2: kr<3.825 1st minimum
        if(ifile.eq.ifile_dmin.and.im.eq.im_dmin) then
         i_spnyq=i_min
c        write(6,*)'Spatial Nyq. at ',i_spnyq,fr(i_spnyq)
        endif
        if(n_flg(2).eq.1) then
         if(fr(i_min).lt.frma(im,ifile)) frma(im,ifile)=fr(i_min)
c        write(6,*)'Flag#2 on:',ifile,'-th  file,',
c    *             im,'-th distance',frmi(im,ifile),
c    *                                     '(Hz) to',frma(im,ifile)
        endif
c narrowing the frequency range 
c       rmdmin=r(ir)*2.  ! Spacial Nyquist freq. kr=pi, SPAC_cof=-0.304
c       rmdmax=r(ir)*7.  ! Critical level        kr=0.9,SPAC_cof= 0.808
        ii_min=i_max     ! data number of positive peak
        ii_max=i_min     ! data number of negative peal
c narrowing longer wavelength limit of critical range
        do i=i_max,i_min
         if(cr(i,ir).lt.0.999) then
c        if(cr(i,ir).lt.0.808) then
          ii_min=i
          goto 114
         endif
        enddo
  114   continue
        if(fr(ii_min).gt.frmi(im,ifile)) then
         frmi(im,ifile)=fr(ii_min)
         write(6,*)im,ifile,frmi(im,ifile),'(Hz) to',
     *                      frma(im,ifile),'(Hz).'
        endif
c narrowing by spatial Nyquist 
        do i=i_min,i_max,-1
	 if(cr(i,ir).gt.-0.304) then
          ii_max=i
          goto 116
         endif
        enddo
  116   continue
c control flag #3: kr<pi
        if(n_flg(3).eq.1) then
         if(ifile.ne.ifile_dmin.or.im.ne.im_dmin) then
          if(fr(ii_max).lt.frma(im,ifile)) frma(im,ifile)=fr(ii_max)
c        write(6,*)'Flag#3 on:',ifile,'-th  file,',
c    *             im,'-th distance',frmi(im,ifile),
c    *                                     '(Hz) to',frma(im,ifile)
         endif
        endif
       enddo
      enddo
      if(int(real(i_spnyq)*0.98).le.nf0) then
       inyq=min(nf0,int(real(i_spnyq)*0.98))
       write(6,*)'High frequency side constraint: Spatial Nyq.*0.98'
      else
       inyq=nf0
       write(6,*)'High frequency side constraint: given by SPAC coeff.'
      endif
      do ifile=1,nfile
       do im=1,mm(ifile)
        if(fr(inyq).lt.frma(im,ifile)) frma(im,ifile)=fr(inyq)
       enddo
      enddo
c cut out the wavelength range shorter than the Nayquist 
c one of the minimum distance
      do ifile=1,nfile
       do im=1,mm(ifile)
	if(ifile.eq.1) ir=im
	if(ifile.eq.2) ir=im+mm(1)
	if(ifile.eq.3) ir=im+mm(1)+mm(2)
	if(ifile.eq.4) ir=im+mm(1)+mm(2)+mm(3)
	if(ifile.eq.5) ir=im+mm(1)+mm(2)+mm(3)+mm(4)
        write( 6,'(i8,3f8.2)') ir,r(ir),frmi(im,ifile),frma(im,ifile)
        write(15,'(i8,3f8.2)') ir,r(ir),frmi(im,ifile),frma(im,ifile)
       enddo
      enddo
      close(15)
c For the case of minimum distance: limitation at a half of Nyquist wavelength
c total number of interstation distances nrmax
      f_minimum=frmi(1,1)
      f_maximum=frma(mm(nfile),nfile)
      do ifile=1,nfile
       do im=1,mm(ifile)
        if(f_minimum.gt.frmi(im,ifile))f_minimum=frmi(im,ifile) 
        if(f_maximum.lt.frma(im,ifile))f_maximum=frma(im,ifile) 
c       write(6,*)f_minimum,f_maximum
       enddo
      enddo
      if(fmin.lt.f_minimum) fmin=f_minimum
      if(fmax.gt.f_maximum) fmax=f_maximum
c      fmax=frma(1,1)
c set variance big for the frequencies out of the range of analysis
      do ifile=1,nfile
       do im=1,mm(ifile)
c       write(6,*)frmi(im,ifile),frma(im,ifile)
        do i=1,nf0
         if(fr(i).lt.frmi(im,ifile).or.fr(i).gt.frma(im,ifile)) then
          if(ifile.eq.1) sd0(i,im)=big
          if(ifile.eq.2) sd0(i,im+mm(1))=big
          if(ifile.eq.3) sd0(i,im+mm(1)+mm(2))=big
          if(ifile.eq.4) sd0(i,im+mm(1)+mm(2)+mm(3))=big
          if(ifile.eq.5) sd0(i,im+mm(1)+mm(2)+mm(3)+mm(4))=big
         endif
        enddo
       enddo
      enddo
c misfit function calculated from cr(i,irad) & sd0(i,irad):variance
      n_vel=min(int(vel_max-vel_min+0.5),mmax)
      d_vel=(vel_max-vel_min)/n_vel
      do i=1,nf0
        do j=1,n_vel
         vel=vel_min+real(j-1)*d_vel
         sum=0.
         smm=0.   
	 do irad=1,nrmax
c          write(6,*)i,j,n_vel,irad
          if(sd0(i,irad).le.big*eps0) then
           cal=bessj0(pi2*fr(i)*r(irad)/vel)
           nsum=nsum+1
           sum=sum+(cr(i,irad)-cal)**2/sd0(i,irad)     !sd0() is variance
           smm=smm+1./sd0(i,irad)
          endif
	 enddo
         if(smm.lt.1.e-12) then
          f_misfit(i,j)=big
         else
          f_misfit(i,j)=sum/smm                        ! misfit function      
         endif
        enddo
      enddo
c search for the minimum of misfit function at each frequency
c determination of cvl(i): phase velocity
      do i=1,nf0
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
        a_min=f_misfit(i,1)
        j_min=1
        do j=1,n_vel
         if(a_min.gt.f_misfit(i,j)) then
          a_min=f_misfit(i,j)
          j_min=j
         endif
        enddo
        cvl(i)=vel_min+real(j_min-1)*d_vel
       endif
      enddo
c estimation of std(i): variance of phase velocity 
      do i=1,nf0
       sum=0.0
       ak=pi2*fr(i)/cvl(i)
       do irad=1,nrmax
        if(sd0(i,irad).le.big*eps0) then
         akr=ak*r(irad)
         sum=sum+(akr*bessj1(akr))**2/sd0(i,irad)
        endif
       enddo
       if(sum.ge.big) then
        std(i)=1.e-12
       else if(sum.le.1.e-12) then
        std(i)=big
       else
        std(i)=cvl(i)**2/sum       ! Variance!
       endif
      enddo
c Setting the minimum velocity for plotting: vmin0
      vcmin=vmax0
      do i=2,nf0
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
        if(vcmin.gt.cvl(i)) then
         vcmin=cvl(i)
        endif
       endif
      enddo
      vmin0=min(vcmin,vmin0)
c Setting the maximum velocity for plotting: vmax0
      vcmax=vmin0
      icmax=1
      do i=2,nf0
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
        if(vcmax.lt.cvl(i)) then
         vcmax=cvl(i)
         icmax=i
        endif
       endif
      enddo
c control flag #4
      if(n_flg(4).eq.1) then
       fmin=fr(icmax)
      endif
c
c      do i=1,nf0-1
c       if(fr(i).le.fmin.and.fr(i+1).gt.fmin) i_st=i
c      enddo
c      do i=nf0,2,-1
c       if(fr(i-1).le.fmax.and.fr(i).gt.fmax) i_ed=i-1
c      enddo
c      write(6,*)'#',i_st,fr(i_st),i_ed,fr(i_ed),fmin,fmax
c      do i=1,min(nf0-i_ed,i_ed)
c       cvl(i_ed+i)=cvl(i_ed-i)
c      enddo
c     write(6,'(2i4,f10.3)')(i_ed,i,cvl(i),i=1,nf0)
c smoothing dispersion curve cvl(i) & std(i)
c      if(smthf.gt.1.e-6) then
c       call esmthf(cvl,cdm,mmax,fr,i_ed,nf0,smthf)
c       do i=1,nf0
c        cvl(i)=cdm(i)
c       enddo 
c       call esmthf(std,cdm,mmax,fr,i_ed,nf0,smthf)
c       do i=1,nf0
c        std(i)=cdm(i)
c       enddo 
c      endif
c
      write(6,*) 'Range of analysis: fmin=',fmin,' fmax=',fmax
      vmax0=max(vcmax,vmax0)
c windening the plotting range of velocity
      vmin0=max(vmin0*0.8,vel_min)
      vmax0=min(vmax0*1.2,vel_max)
c     write(6,*)'vmin0=',vmin0,vmin,vcmin,' vmax0=',vmax0,vmax,vcmax
c out put to "comparison.dat"
      rmin=r(1)
      rmax=r(1)
      do irad=1,nrmax
       if(rmin.gt.r(irad)) rmin=r(irad)
       if(rmax.lt.r(irad)) rmax=r(irad)
      enddo
      if(n_comparison.eq.1) then
       filen=cwkf(1:23)//'comparison.dat'
       open(1,file=filen,status='unknown')
       dr=(r(nrmax)-r(1))/20.
       do i=1,nf0
	if(fr(i).ge.fmin.and.fr(i).le.fmax) then
         write(1,'(a3,f9.3,a12,f7.2,a14)')
     *         ' f=',fr(i),'        Hz    ',cvl(i),'           =c '
         write(1,*)'       r    SPAC_Coef.     Cal_Bessel     S.D.'
         write(1,'(2(f12.3,12x))')0.0,1.0
         do ir=1,nrmax
          if(sd0(i,ir).le.big*0.1) then 
           pr=pi2*fr(i)*r(ir)/cvl(i)
           yy=bessj0(pr)
           write(1,'(i3,f9.3,3f12.3)')
     *                 ir,r(ir),cr(i,ir),yy,sqrt(sd0(i,ir))
          endif
         enddo
        endif
       enddo
       close(1)
      endif
c output to "SPAC_coef.dat"
      filen=cwkf(1:23)//'SPAC_coef.dat'
      open(1,file=filen,status='unknown')
      cdummy=''
c     write(6,'(i2)')nrmax
      if(nrmax.lt.10) then
       write(cdummy,'(a7,1x,i1,a10)')'(I7,1x,',nrmax,'(f7.1,a1))'
      else if(nrmax.lt.100) then
       write(cdummy,'(a7,i2,a10)')'(I7,1x,',nrmax,'(f7.1,a1))'
      endif
      write(1,cdummy(1:19))nrmax,(r(irad),'m',irad=1,nrmax)
c
      if(nrmax.lt.5) then
       write(cdummy,'(a1,1x,i1,a5)')'(',nrmax*2+1,'f8.3)'
      else if(nrmax.lt.50) then
       write(cdummy,'(a1,i2,a5)')'(',nrmax*2+1,'f8.3)'
      endif
      do i=1,nf0
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
        do irad=1,nrmax
         if(sd0(i,irad).ge.1.e3) then
          xxdm(irad)=999.999
         else
          xxdm(irad)=sqrt(sd0(i,irad))
         endif
        enddo
        write(1,cdummy(1:8))fr(i),(cr(i,irad),irad=1,nrmax)
     *                      ,(xxdm(irad),irad=1,nrmax)
       endif
      enddo
      close(1)
c output to "temp15.dat"
      filen=cwkf(1:23)//'temp15.dat'
      open(1,file=filen,status='unknown')
      if(nrmax.le.9) then
       write(cdummy,'(a6,1x,i1,a3)')'(f8.3,',nrmax,'a8)'
      else if(nrmax.le.99) then
       write(cdummy,'(a6,   i2,a3)')'(f8.3,',nrmax,'a8)'
      endif
      do i=1,nf0
       if(fr(i).ge.fmin0.and.fr(i).le.fmax0) then
        do irad=1,nrad
         if(abs(cr(i,irad)).gt.1.e-3) then
          write(ccr(irad),'(f8.3)') cr(i,irad)
         else
          write(ccr(irad),  '(a8)') '   NAN  '
         endif
        enddo
        write(1,cdummy(1:11))fr(i),(ccr(irad),irad=1,nrmax)
       endif
      enddo
      close(1)
c output to "vel_model.dat"
      filen=cwkf(1:23)//'vel_model.dat'
      open(1,file=filen,status='unknown')
      write(1,'(2a12)')'#  freq.(Hz)',' Vel.(km/s) '
      do i=1,nf0                                       ! ,10
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
        if(cvl(i).gt.vmin0) then
         write(1,'(3f12.3)')fr(i),cvl(i)/1000.,sqrt(std(i))/1000.
        endif                  ! std() variance ==> SD
       endif
      enddo
      close(1)
c output for "temp0.dat" for plotting using gnuplot: misfit function
c normalize by the maximum
      do i=1,nf0
       amax=0.0   !  f_misfit(1,1)
        do j=1,n_vel
         if(f_misfit(i,j).le.big*0.1) then
          if(amax.lt.f_misfit(i,j)) then
           amax=f_misfit(i,j)
          endif
         endif
        enddo
c       write(6,*)i,fr(i),amax
        do j=1,n_vel
         if(amax.le.1.e-12) then
          f_misfit(i,j)=2.0
         else
          f_misfit(i,j)=f_misfit(i,j)/amax
         endif
        enddo
c cut the big values: aps is a parameter given in cf_panel1.prm
        do j=1,n_vel
         if(f_misfit(i,j).ge.aps) f_misfit(i,j)=aps
         f_misfit(i,j)=f_misfit(i,j)/aps
        enddo
      enddo
      cwkf=cdrv//'data/results/'
      filen=cwkf(1:23)//'temp0.dat'
      open(1,file=filen,status='unknown')
      do i=1,nf0
       if(fr(i).gt.fmin0.and.fr(i).lt.fmax0) then
        do j=1,n_vel
         write(1,*)fr(i),vel_min+real(j-1)*d_vel,f_misfit(i,j)
        enddo
        write(1,*)
       endif
      enddo
      close(1)
      filen=cwkf(1:23)//'misfit.dat'
      open(1,file=filen,status='unknown')
      do i=1,nf0
       if(fr(i).gt.fmin0.and.fr(i).lt.fmax0) then
        do j=1,n_vel
         write(1,*)fr(i),vel_min+real(j-1)*d_vel,f_misfit(i,j)
        enddo
        write(1,*)
       endif
      enddo
      close(1)
c output for "temp1.dat" for plotting using gnuplot
      cwkf=cdrv//'data/results/'
      filen=cwkf(1:23)//'temp1.dat'
      open(1,file=filen,status='unknown')
      write(1,'(a1,4x,a5,2x,a8)')'#','Freq.','Velocity'
      do i=1,nf0
       if(fr(i).ge.fmin.and.fr(i).le.fmax) then
       if(cvl(i).gt.vmin0) then
        write(1,'(f10.3,2f10.3)')fr(i),cvl(i),1. ! std(i)
       endif
       endif  
      enddo
      close(1)
c output for "temp2.dat" for plotting using gnuplot
      cwkf=cdrv//'data/results/'
      filen=cwkf(1:23)//'temp2.dat'
      open(1,file=filen,status='unknown')
      do i=1,nf0
        write(1,*) fr(i),fr(i)*2.*rmin,1.0         ! lower reliable range
      enddo
      close(1)
c output for "temp3.dat" for plotting using gnuplot
      filen=cwkf(1:23)//'temp3.dat'                 ! upper reliable range
      open(1,file=filen,status='unknown')
      do i=1,nf0
        write(1,*) fr(i),fr(i)*1.*rmax,1.0
      enddo
      close(1)
c output for "temp4.dat" for plotting using gnuplot
      filen=cwkf(1:23)//'temp4.dat'                ! upper acceptable range
      open(1,file=filen,status='unknown')
      do i=1,nf0
        write(1,*) fr(i),fr(i)*3.*rmax,1.0 
      enddo
      close(1)
c output for "temp5.dat" for plotting using gnuplot
      filen=cwkf(1:23)//'temp5.dat'                   ! upper critical range
      open(1,file=filen,status='unknown')
      do i=1,nf0
        write(1,*) fr(i),fr(i)*7.*rmax,1.0 
      enddo
      close(1)
c
      filen='./spacwkf/prm/gnuplt_script/SPAC_coef.plt'
      write(6,*)filen
      open(12,file=filen,status='unknown')
      filen=cwkf(1:23)//'temp15.dat'
      write(12,*)'reset'
      write(12,*)'set key title ''Inter-Station Distance'''
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:50)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Frequency (Hz)"'
      write(12,*)'set xrange [',fmin0,':',fmax0,']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "SPAC Coefficient Curves"'
      write(12,*)'set yrange [',-0.5,':',1.0,']'
      write(12,*)'set grid'
      write(12,*)'set multiplot'
      write(cform,'(a5,i2,a39)')
     *           '(a6,a',33,',a10,i2,a20,i2,a8,f6.1,a1,a4)'
      ich=2
      write(12,cform)'plot "',filen(1:33),
     *        '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *        ' title "',r(ich-1),'m','", \'  
      do ich=3,nrmax
       write(12,cform)'     "',filen(1:33),
     *        '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *        ' title "',r(ich-1),'m','", \'
      enddo
      ich=nrmax+1
      write(12,cform)'     "',filen(1:33),
     *       '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *       ' title "',r(ich-1),'m','"   '
      write(12,*)'unset multiplot'
c
      write(12,*)'set terminal postscript color noenhanced'
      write(12,*)
     *     'set output "./spacwkf/data/results/fig_results/'//
     *                              'SPAC_coef'//'.ps"'
      write(12,*)'reset'
      write(12,*)'set key title ''Inter-Station Distance'''
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:50)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Frequency (Hz)"'
      write(12,*)'set xrange [',fmin0,':',fmax0,']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "SPAC Coefficient Curves"'
      write(12,*)'set yrange [',-0.5,':',1.0,']'
      write(12,*)'set grid'
      write(12,*)'set multiplot'
      write(cform,'(a5,i2,a39)')
     *           '(a6,a',33,',a10,i2,a20,i2,a8,f6.1,a1,a4)'
      ich=2
      write(12,cform)'plot "',filen(1:33),
     *        '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *        ' title "',r(ich-1),'m','", \'  
      do ich=3,nrmax
       write(12,cform)'     "',filen(1:33),
     *        '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *        ' title "',r(ich-1),'m','", \'
      enddo
      ich=nrmax+1
      write(12,cform)'     "',filen(1:33),
     *       '" using 1:',ich,' with lines lw 3 lc ',ich-1,
     *       ' title "',r(ich-1),'m','"   '
      write(12,*)'unset multiplot'
      write(12,*)'set output'
      write(12,*)'set terminal x11'
      close(12)
c >>>>                                                             <<<<
c >>>> output for plotting file cf_panel1.plt                       <<<<
c >>>>                                                             <<<<
c 
      filen='./spacwkf/prm/gnuplt_script/cf_panel1.plt'
      write(6,*)filen
      open(12,file=filen,status='unknown')
      write(12,*)'reset'
      write(12,*)'unset key'
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:50)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Frequency (Hz)"'
      write(12,*)'set xrange [',fmin0,':',fmax*1.05,']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "Phase Velocity (m/s)"'
      write(12,*)'set yrange [',vmin0,':',vmax0,']'
      write(12,*)'set grid'
      write(12,*)'# C-F spectra '
      write(12,*)'set zrange [0:1]'
      write(12,*)'#'
      write(12,*)'set pm3d map'
      write(12,*)'set multiplot'
      write(12,*)'splot "./spacwkf/data/results/temp0.dat"'    ! f_misfit
      write(12,*)'splot "./spacwkf/data/results/temp1.dat"'
     *            //' with points pt 7 ps 1 lc rgb "plum"'     ! obs
      write(12,*)'splot "./spacwkf/data/results/temp2.dat"'  
     *                  //' with lines lt 1 lc rgb "green"'    ! reliable
      write(12,*)'splot "./spacwkf/data/results/temp3.dat"'  
     *                  //' with lines lt 1 lc rgb "green"'    ! reliable
      write(12,*)'splot "./spacwkf/data/results/temp4.dat"'
     *                  //' with lines lt 1 lc rgb "cyan"'     ! acceptable
      write(12,*)'splot "./spacwkf/data/results/temp5.dat"'
     *                  //' with lines lt 1 lc rgb "violet"'   ! critical
      write(12,*)'unset multiplot'
c
      write(12,*)'set terminal postscript color enhanced'
      write(12,*)
     * 'set output "./spacwkf/data/results/fig_results/cf_panel.ps"'
      write(12,*)'reset'
      write(12,*)'unset key'
      write(12,*)'# Graph title'
      write(12,*)'set title "'//com1(1:50)//' "'
      write(12,*)'# Horizontal axis: label & range'
      write(12,*)'set xlabel "Frequency (Hz)"'
      write(12,*)'set xrange [',fmin0,':',fmax*1.05,']'
      write(12,*)'# Verical axis: label & range'
      write(12,*)'set ylabel "Phase Velocity (m/s)"'
      write(12,*)'set yrange [',vmin0,':',vmax0,']'
      write(12,*)'set grid'
      write(12,*)'# C-F spectra '
      write(12,*)'set zrange [0:1]'
      write(12,*)'#'
      write(12,*)'set pm3d map'
      write(12,*)'set multiplot'
      write(12,*)'splot "./spacwkf/data/results/temp0.dat"'    ! f_misfit
      write(12,*)'splot "./spacwkf/data/results/temp1.dat"'
     *            //' with points pt 7 ps 1 lc rgb "plum"'     ! obs
      write(12,*)'splot "./spacwkf/data/results/temp2.dat"'  
     *                  //' with lines lt 1 lc rgb "green"'    ! reliable
      write(12,*)'splot "./spacwkf/data/results/temp3.dat"'  
     *                  //' with lines lt 1 lc rgb "green"'    ! reliable
      write(12,*)'splot "./spacwkf/data/results/temp4.dat"'
     *                  //' with lines lt 1 lc rgb "cyan"'     ! acceptable
      write(12,*)'splot "./spacwkf/data/results/temp5.dat"'
     *                  //' with lines lt 1 lc rgb "violet"'   ! critical
      write(12,*)'unset multiplot'
      write(12,*)'set output'
      write(12,*)'set terminal x11'
      close(12)
c
      stop
      end
c+++++
      FUNCTION bessj0(x)
      REAL bessj0,x
      REAL ax,xx,z
      DOUBLE PRECISION p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,
     *s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,
     *s5,s6
      DATA p1,p2,p3,p4,p5/1.d0,-.1098628627d-2,.2734510407d-4,
     *-.2073370639d-5,.2093887211d-6/, q1,q2,q3,q4,q5/-.1562499995d-1,
     *.1430488765d-3,-.6911147651d-5,.7621095161d-6,-.934945152d-7/
      DATA r1,r2,r3,r4,r5,r6/57568490574.d0,-13362590354.d0,
     *651619640.7d0,-11214424.18d0,77392.33017d0,-184.9052456d0/,s1,s2,
     *s3,s4,s5,s6/57568490411.d0,1029532985.d0,9494680.718d0,
     *59272.64853d0,267.8532712d0,1.d0/
      if(abs(x).lt.8.)then
        y=x**2
        bessj0=(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+y*
     *(s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8./ax
        y=z**2
        xx=ax-.785398164
        bessj0=sqrt(.636619772/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*
     *p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))
      endif
      return
      END
c+++++
      FUNCTION bessj1(x)
      REAL bessj1,x
      REAL ax,xx,z
      DOUBLE PRECISION p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,
     *s1,s2,s3,s4,s5,s6,y
      SAVE p1,p2,p3,p4,p5,q1,q2,q3,q4,q5,r1,r2,r3,r4,r5,r6,s1,s2,s3,s4,
     *s5,s6
      DATA r1,r2,r3,r4,r5,r6/72362614232.d0,-7895059235.d0,
     *242396853.1d0,-2972611.439d0,15704.48260d0,-30.16036606d0/,s1,s2,
     *s3,s4,s5,s6/144725228442.d0,2300535178.d0,18583304.74d0,
     *99447.43394d0,376.9991397d0,1.d0/
      DATA p1,p2,p3,p4,p5/1.d0,.183105d-2,-.3516396496d-4,
     *.2457520174d-5,-.240337019d-6/, q1,q2,q3,q4,q5/.04687499995d0,
     *-.2002690873d-3,.8449199096d-5,-.88228987d-6,.105787412d-6/
      if(abs(x).lt.8.)then
        y=x**2
        bessj1=x*(r1+y*(r2+y*(r3+y*(r4+y*(r5+y*r6)))))/(s1+y*(s2+y*(s3+
     *y*(s4+y*(s5+y*s6)))))
      else
        ax=abs(x)
        z=8./ax
        y=z**2
        xx=ax-2.356194491
        bessj1=sqrt(.636619772/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*
     *p5))))-z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))*sign(1.,x)
      endif
      return
      END
c+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine esmthf(ai,ao,mmax,f,nf,nf0,smthf)                               
c  subroutine for smoothing spectra or spectral ratio
c  window's shape: Parzen                   
      dimension ai(mmax),ao(mmax),f(nf0)                               
      real madd 
      if(smthf.le.0.0) go to 100                                        
      ao(1)=ai(1)                                                       
      do 35 i=2,nf                                                      
       f1=(1.0-0.5*smthf)*f(i)                                           
       f2=(1.0+0.5*smthf)*f(i)                                           
       u=1.854305/(smthf*f(i))
       if(f2.le.f(nf))go to 31                                           
   31  sum=0.0                                                           
       madd=0.0                                                          
       do 32 k=1,nf                                                      
        if(f(k).lt.f1) go to 32                                           
        if(f(k).gt.f2) go to 33                                           
        au=1.570796*u*abs(f(i)-f(k))
        if(i.eq.k) then
         w=0.75*u
        else
         w=0.75*u*(sin(au)/au)**4
        endif
        sum=sum+ai(k)*w                                                     
        madd=madd+W                                                       
   32  continue                                                          
   33  continue                                                          
       ao(i)=sum/madd                                                    
   35  continue                                                          
   36 continue                                                          
c      nf=mnf                                                            
      return                                                            
  100 continue                                                          
      do 101 i=1,nf                                                     
  101 ao(i)=ai(i)                                                       
      return                                                            
      end                                       
