      program distazi
c
c calculate the inter-station distances and azimuths for the given staion coordinates.
c 
      parameter(nsta0=48,ndst0=(nsta0-1)*nsta0/2)
      real*8 xla(nsta0),ylo(nsta0),xorg,yorg,delta,azi,bazi
      real x(nsta0),y(nsta0),
     *     di(nsta0),az(nsta0),dd(nsta0,nsta0),
     *     aa(nsta0,nsta0),ds(ndst0),as(ndst0) 
      integer id(nsta0),id1(ndst0),id2(ndst0)
      character filen*80,cdm1*80,cdrv*18,cwkf*10,cdum*4
c working folder name
      cwkf='./spacwkf/'
      cdrv=cwkf//'prm/'
      data pai/3.14159265358979/ big/1.0e10/
      fac=pai/180.
      filen=cdrv(1:14)//'distazi.prm'
c     write(6,*)filen
      open(1,file=filen, status='old')
      read(1,'(a45)')cdm1
      read(1,*)ntype
      if(ntype.eq.0) then
       write(6,*)' X-Y coordinates are selected'
       read(1,*)nsta,cdum
       do ista=1,nsta
        read(1,*)x(ista),y(ista),id(ista)
       enddo
       do ista=1,nsta
        write(6,*)id(ista),x(ista),y(ista)
       enddo
       close(1)
      else if(ntype.eq.1) then
       write(6,*)' Lat-Long coordinates are selected'
c      write(6,*)''
       read(1,*)nsta,cdum
       do ista=1,nsta
c       read(1,*)xmm,xss,ymm,yss,id(ista)
c       xla(ista)=xmm+xss/60.
c       ylo(ista)=ymm+yss/60.
        read(1,*)xla(ista),ylo(ista),id(ista)
        write(6,*)id(ista),xla(ista),ylo(ista)
       enddo
       write(6,*)'The origin is set at the last station.'
       xorg=xla(nsta)
       yorg=ylo(nsta)
c      write(6,*) 'origin:',xorg,yorg
       do ista=1,nsta-1
        call distazi0(xorg,yorg,xla(ista),ylo(ista),delta,azi,bazi)
        di(ista)=real(delta)*1000.      ! km==>m
        az(ista)=real(azi)
       enddo
       di(nsta)=0.0
       az(nsta)=0.0
       do ista=1,nsta
        write(6,*) id(ista),di(ista),az(ista)
       enddo
       do ista=1,nsta
        x(ista)=di(ista)*sin(az(ista)*fac)
       enddo
       do ista=1,nsta
        y(ista)=di(ista)*cos(az(ista)*fac)
       enddo
       do ista=1,nsta
        write(6,'(i8,2f8.1)')id(ista),x(ista),y(ista)
       enddo
      else if(ntype.eq.2) then
       write(6,*)' Dist-Azimuth coordinates are selected'
       write(6,*)'X-axis toward East, Y-axis toward North.'
       read(1,*)nsta,cdum
       do ista=1,nsta
        read(1,*)di(ista),az(ista),id(ista)
       enddo
c       do ista=1,nsta
c        write(6,*)id(ista),di(ista),az(ista)
c       enddo
       close(1)
       do ista=1,nsta
        x(ista)=di(ista)*sin(az(ista)*fac)
       enddo
       do ista=1,nsta
        y(ista)=di(ista)*cos(az(ista)*fac)
       enddo
       do ista=1,nsta
        write(6,'(i8,2f8.1)')id(ista),x(ista),y(ista)
       enddo
      else
       write(6,*)' This type is not yet available'
       close(1)
       stop
      endif
c output to temporary file for geometry plot.
      open(12,file='./spacwkf/data/results/temp0.dat',status='unknown')
      write(12,'(a45)')cdm1
      write(12,'(i5,1x,a4)')nsta,cdum
      do ista=1,nsta
       write(12,'(2f12.5,i12)')x(ista),y(ista),id(ista)
      enddo
      close(12)
c distance and azimuth
      do i1=1,nsta
       do i2=i1+1,nsta
        dd(i1,i2)=sqrt((x(i2)-x(i1))**2+(y(i2)-y(i1))**2)
        aa(i1,i2)=atan2(x(i2)-x(i1),y(i2)-y(i1))
        if(abs(abs(aa(i1,i2))-180.0).le.1.e-6) aa(i1,i2)=180.0/fac
        if(abs(aa(i1,i2)).le.1.e-6) aa(i1,i2)=0.0
	write(6,*)i1,i2,dd(i1,i2),aa(i1,i2)/fac
       enddo
      enddo
c sorting by distance
c      write(6,*)nsta
      ndst=(nsta-1)*nsta/2
      do idst=1,ndst
       ds_min=big
	 do i1=1,nsta
        do i2=i1+1,nsta
         if(dd(i1,i2).lt.ds_min) then
          ds_min=dd(i1,i2)
          id1(idst)=i1
          id2(idst)=i2
         endif
	  enddo
	 enddo
c	write(6,*) id1(idst),id2(idst)
       ds(idst)=dd(id1(idst),id2(idst))
       as(idst)=aa(id1(idst),id2(idst))
       dd(id1(idst),id2(idst))=big
      enddo
      cdrv=cwkf//'data/'
      write(6,*)cdrv
      filen=cdrv(1:15)//'results/distazi.dat'
      write(6,*)filen
      open(2,file=filen,status='unknown')
c      write(6,'(a45)')cdm1
      write(2,'(a45)')cdm1
      write(2,'(i5,a24)')nsta,'      :number of station'
      write(2,'(3(10x,a2))')'ID','X ','Y '
      do ista=1,nsta
       write(2,'(i12,2f12.6)')id(ista),x(ista),y(ista)
      enddo
      write(2,*)'   id','  st1','  st2',' distance','  azimuth'
      do idst=1,ndst
       write(6,'(3I5,2f9.3)')
     *           idst,id(id1(idst)),id(id2(idst)),ds(idst),as(idst)/fac
       write(2,'(3I5,2f9.3)')
     *           idst,id(id1(idst)),id(id2(idst)),ds(idst),as(idst)/fac
	enddo
c
      stop
      end
c
      subroutine distazi0(evlarr,evlor,stlarr,stlor,delta,azi,bazi)
      implicit double precision (a-h,o-z)
      data pai/3.14159265D0/ r0/6369.0D0/ 
c input lat., long. in degree
c Geographical==>Geocentric Latutude
      fac=pai/180.D0
      evlar=evlarr-0.1925D0*sin(evlarr*fac)
      stlar=stlarr-0.1925D0*sin(stlarr*fac)
      evla=evlar*fac
      evlo=evlor*fac
      stla=stlar*fac
      stlo=stlor*fac
      ae=dcos(evla)*dcos(evlo)
      as=dcos(stla)*dcos(stlo)
      be=dcos(evla)*dsin(evlo)
      bs=dcos(stla)*dsin(stlo)
      ce=dsin(evla)
      cs=dsin(stla)
      a=dsqrt((ae-as)**2+(be-bs)**2+(ce-cs)**2)/2.D0
      at=datan(a/sqrt(-a*a+1.D0))*2.D0
c epicentral distance in km
      delta=at*r0
      ae=dsin(stla)*dcos(evla)-dcos(stla)*dsin(evla)*dcos(stlo-evlo)
      be=dsin(evla)*dcos(stla)-dcos(evla)*dsin(stla)*dcos(evlo-stlo)
      ae=ae/dsin(at)
      be=be/dsin(at)
      aa=dsqrt(1-ae**2)/ae
      aaa=dsqrt(1-be**2)/be
c azimuth(ev==>st) & back azimuth(st==>ev) in degree
      azi=datan(aa)/fac
c      aa=dcos(stla)*dsin(stlo-evlo)
c      aaa=dcos(evla)*dsin(stla)-dsin(evla)*dcos(stla)*dcos(stlo-evlo)
c      azi=datan2(aa,aaa)/fac
c      aa=dcos(evla)*dsin(evlo-stlo)
c      aaa=dcos(stla)*dsin(evla)-dsin(stla)*dcos(evla)*dcos(evlo-stlo)
      bazi=datan(aaa)/fac
      write(6,*)delta,azi
      if ((evlo.ge.stlo).and.(evla.gt.stla)) then
       azi=180.D0+dabs(azi)
      else
       if ((evlo.gt.stlo).and.(evla.le.stla)) then
        azi=360.D0-azi
       else
        if ((evlo.lt.stlo).and.(evla.ge.stla)) then
         azi=180.D0-dabs(azi)
        endif
       endif
      endif
      return
      end  
