      include 'dgflt.f'
      program resample6
c program to resample, multiplex and mask the microtremor data observed 
c independently & simultaneously.
c
c				                Jun,18,2008 T. Yokoi, IISEE, BRI
c
c Modified for double screening: by peak/rms and 
c                                by deviation of rms from average
c                                 May,12,2009 T. Yokoi, IISEE, BRI
c Modified for multiplexed input data file
c                                 Apr,13,2010 T. Yokoi, IISEE, BRI
c Renovated                       Mar.10,2017 T. Yokoi, IISEE, BRI
      parameter(nmax=900000,nch0=11,nblk0=8192,
     *          mblk0=3000,n_mea0=100)
      character filen*80,cfn(n_mea0)*8,cout*12,comment*50,
     *          cform1*15,cform2*20,cform3*18,cform4*18
      character cdrv*10,cwkf*50,cunit*5
      real*4 x(nmax,nch0),xx(nmax),y(nblk0,nch0),peak(nch0),rmsa(nch0),
     *       rms(mblk0,nch0),aver(nch0),sgm(nch0)
      real*4 z(nmax,nch0),q(nblk0,nch0)                     ! jun14
      integer iflg(mblk0),mblkmea(n_mea0) 
      data cdrv/'./spacwkf/'/ 
c default values
      data fl,fh,fs/0.033,19.,19.5/ ap,as/0.1,10.0/ ajudge/4./
     *     a_sgm/2/ ph0/0.0/
c     data fl1,fh1,fs1/0.1,19.0,19.5/                          ! jun14
      data fl1,fh1,fs1/0.1,1.0,1.5/                            ! Nov22
c Chebishev I(2), Lowpass (2) Bandpass(3), Causal(1)
      data ntype,nchara,ncausal/2,3,1/
c working folder name
      cwkf=cdrv//'prm//'
c temporary file 
      open(12,status='scratch')
      open(13,status='scratch')                              ! jun14
c     filen=cdrv//'data/results/temp.dat'
c     open(12,file=filen,status='unknown')
c
      filen=cwkf(1:14)//'resample6.prm'
      write(6,*)filen
      open(10,file=filen,status='old')
      write(6,*)' Working Folder=',cwkf
c channel number, initial azimuth, sampling interval, resampling rate
      read(10,*) nch,dt,nskip
      fnyquist=1./(2.*dt*real(nskip))
      fs=fnyquist*0.9
      fh=fs*0.9
c	fs=1.5
c      fh=1.0
      if(nskip.ge.2) then
       if(nchara.eq.2) then
	  write(6,*)'Low-Pass:','fh=',fh,'fs=',fs
       else if(nchara.eq.3) then
	  write(6,*)'Band-Pass:','fl=',fl,'fh=',fh,'fs=',fs
       endif
      endif
	dt1=dt*nskip
      write(6,*)' Nch=',nch
      write(6,*)' Nskip=',nskip,' f(Nyquist)=',fnyquist,' fh=',fh
      call formatter(nch,cform1,cform2,cform3,cform4)
      read(10,*) ajudge,a_sgm
      write(6,*)' ajudge=', ajudge,' a_sgm=',a_sgm
c start and end time 
      read(10,*) tst,tdur
	write(6,*) tst,tdur
      nst0=int(tst/dt)+1
      ndur0=int(tdur/dt)
      scale=1.0
c output file name
      read(10,*)cout
c number of data in one time block after resampling
      read(10,*) nblk
c number of measurement in the same array configuration
      read(10,*)n_mea
      write(6,*)' First screening (peak/rms<',ajudge,'):'
      do i_mea=1,n_mea
       ndat=ndur0/nskip
c input file names
       read(10,*)cfn(i_mea)
c      write(6,cform1)cfn(i_mea)
       cwkf=cdrv//'data/multiplexed_files/'
       filen=cwkf(1:33)//cfn(i_mea)
       write(6,*)i_mea,'-th measurement:',filen(1:45)
       open(1,file=filen,status='old')
       read(1,*)nch00,dt00,scale00,ndata00,cunit
c       write(6,*)nch00,dt00,scale00,ndata00
       if(nch00.ne.nch) then
	  write(6,*)' nch does not coincide, check the file.'
        stop
       endif
       if(dt00.ne.dt) then
	  write(6,*)' dt does not coincide, check the file.'
        stop
	 endif
       if(ndata00.lt.ndur0+nst0-1.or.nmax.lt.ndur0+nst0-1) then
	  write(6,*)' ndata00     =',ndata00
	  write(6,*)' nmax        =',nmax
	  write(6,*)' ndur0+nst0-1=',ndur0+nst0-1
        stop
	 endif
	 read(1,'(a50)')comment
c	 write(6,*)comment
       do i=1,nst0-1
        read(1,*)
       enddo
       do i=1,ndur0
        read(1,*,end=10) xdum,(x(i,j),j=1,nch)
c       if(abs(x(i,1)).lt.1.e-6) write(6,*) xdum,(x(i,j),j=1,3)
       enddo
   10  ndur0=i-1
c	 
       if(nskip.ge.2) then
        do j=1,nch
         do i=1,ndur0
          xx(i)=x(i,j)
         enddo
         call taper(xx,ndur0,dt)
c
         call bandp1(xx,ndur0,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
c
         do i=1,ndat
          x(i,j)=xx((i-1)*nskip+1)
         enddo
        enddo
       endif
cccc                                                     ! jun14
       do j=1,nch
        do i=1,ndat
         z(i,j)=x(i,j)
        enddo
       enddo
        fh1=min(fh,fh1)
        fs1=min(fs,fs1)
        do j=1,nch
         do i=1,ndat
          xx(i)=x(i,j)
         enddo
         if(nskip.eq.1) then
          call taper(xx,ndur0,dt)
         endif
c
	 if(j.eq.1) write(6,*)'Band-Pass:','fl1=',
     *                                      fl1,'fh1=',fh1,'fs1=',fs1
      call bandp1(xx,ndat,dt1,fl1,fh1,fs1,ap,as,ntype,nchara,ncausal)
c
         do i=1,ndat
          x(i,j)=xx(i)
         enddo
        enddo
cccc
c first screening using the maximum value/rms amplitude
       iblkmx=0
       mblk=0
       iblk=0
       ist=0
  100  continue
c time block start and end
       if(ist.ne.0) then
        ist=ist+nblk/2
       else
        ist=1
       endif
       ied=ist+nblk-1
c escape from loop
       if(ied.gt.ndat) goto 200
       iblk=iblk+1
       do k=1,nblk
        do ich=1,nch
         y(k,ich)=x(ist+k-1,ich)
        enddo
       enddo
c peak value
       do ich=1,nch
        peak(ich)=abs(y(1,ich))
        do k=2,nblk
         if(peak(ich).lt.abs(y(k,ich))) peak(ich)=abs(y(k,ich))
        enddo
c rms amplitude
        sum=0.
        do k=1,nblk
         sum=sum+y(k,ich)**2
        enddo
        rmsa(ich)=sqrt(sum/nblk)
       enddo
c max. value of the ratio=peak/rms over channels
       aratio=peak(1)/rmsa(1)
       do ich=2,nch
        if(aratio.lt.peak(ich)/rmsa(ich)) aratio=peak(ich)/rmsa(ich)
       enddo
c screening
       iblkmx=iblkmx+1
       if(aratio.lt.ajudge) then
        iflg(iblk)=1
        mblk=mblk+1
       else
        iflg(iblk)=0
       endif
c
       goto 100
  200  continue
       write(6,*) mblk,' blocks remained among ',iblkmx,' blocks'
c store in the temporary file
       ist=0
       do iblk=1,iblkmx
        if(iblk.eq.1) then
         write(12,cform2)nch,mblk,ph0 ! ,(cfn(ich),ich=1,nch)
         write(13,cform2)nch,mblk,ph0 ! ,(cfn(ich),ich=1,nch) ! jun14
c        write(6,*)nch,mblk,ph0
        endif
c time block start and end
        if(ist.ne.0) then
         ist=ist+nblk/2
        else
         ist=1
        endif
        ied=ist+nblk-1
c
        if(iflg(iblk).eq.1) then
	   do i=ist,ied
          t=dt1*real(i-1)
          write(12,cform3)i,t,(x(i,ich),ich=1,nch)
c          write(12)i,t,(x(i,ich),ich=1,nch)
          write(13,cform3)i,t,(z(i,ich),ich=1,nch)     ! jun14
         enddo
        endif
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      write(6,*)' Data stored in the temporary file'
c average and variance of rms amplitude
      rewind(12)
      rewind(13)                                        ! jun14
      mmblk=0
      do i_mea=1,n_mea
       read(12,'(4x,i4)') mblk
       read(13,*)                                       ! jun14
c       read(12) n_dum,mblk,adum,(cdum(ich),ich=1,nch)
       do iblk=1,mblk
        do k=1,nblk
         read(12,cform3)i,t,(y(k,ich),ich=1,nch)
         read(13,*)                                     ! jun14
c         write(6,*)iblk,k,i,t
c         read(12)i,t,(y(k,ich),ich=1,nch)
c         if(k.eq.1)    tst=t
c         if(k.eq.nblk) ted=t
        enddo
c rms amplitude
        do ich=1,nch
         sum=0.
         do k=1,nblk
          sum=sum+y(k,ich)**2 
         enddo
         rms(iblk+mmblk,ich)=sqrt(sum/real(nblk))
        enddo
c end of do loop over iblk
       enddo
       mmblk=mmblk+mblk
c end of do loop over i_mea
      enddo
c
      do ich=1,nch
       sum=0.
       do iblk=1,mmblk
        sum=sum+rms(iblk,ich)
       enddo
c average rms amplitude
       aver(ich)=sum/real(mmblk)
       sum=0.
       do iblk=1,mmblk
        sum=sum+(rms(iblk,ich)-aver(ich))**2
       enddo
       var=sum/real(mmblk-1)
c standard deviation
       sgm(ich)=sqrt(var)
      enddo
      mmblk0=mmblk
c
      cwkf=cdrv//'data/resampled_files/'
      filen=cwkf(1:31)//cout
      write(6,*)filen
      open(2,file=filen,status='unknown')
c screening using SD of rms amplitude
      rewind(12)
      rewind(13)                            ! jun14
      icount=0
      iii=0
      do i_mea=1,n_mea
       read(12,'(4x,i4)') mblkmea(i_mea)
       read(13,*)                                     ! jun14
c       write(6,*) mblkmea(i_mea)
       do iblk=1,mblkmea(i_mea)
        do k=1,nblk
         read(12,cform4)t,(y(k,ich),ich=1,nch)
         read(13,cform4)t,(q(k,ich),ich=1,nch)        ! jun14
         if(k.eq.1) tst=t
        enddo
c rms amplitude
        icount=icount+1
        iflg(icount)=1
        do ich=1,nch
         sum=0.
         do k=1,nblk
          sum=sum+y(k,ich)**2 
         enddo
         rrmss=sqrt(sum/real(nblk))
         if(abs(aver(ich)-rrmss).gt.a_sgm*sgm(ich)) then
          mmblk=mmblk-iflg(icount)
          iflg(icount)=0
         endif
        enddo
        if(iflg(icount).eq.1) iii=iii+1
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      if(icount.gt.mblk0) then
       write(6,*)'icount=',icount,', mblk0=',mblk0
       write(6,*)'icount>mblk0!, Use bigger mblk0.'
       stop
      endif
c	write(6,*)mmblk,iii,icount
      rewind(12)
      rewind(13)                                        ! jun14
      icount=0
      iii=0
      ncount=0
      do i_mea=1,n_mea
       read(12,'(4x,i4)') mblkmea(i_mea)
       read(13,*) 
c       write(6,*) mblkmea(i_mea)
c       read(12) n_dum,m_dum,adum,(cdum(ich),ich=1,nch)
       do iblk=1,mblkmea(i_mea)
        ncount=ncount+1
        do k=1,nblk
         read(12,cform4)t,(y(k,ich),ich=1,nch)
         if(k.eq.1) tst=t
         read(13,cform4)t,(q(k,ich),ich=1,nch)       ! jun14
        enddo
c       if(i_mea.eq.1.and.iblk.eq.1) then                   !aca i_mea=1 & mblkmea(i_mea)=0
        if(ncount.eq.1.and.iblk.eq.1) then 
         write(2,'(3i8,2x,a18,1x,a5)') 
     *               nch,mmblk,nblk,cform3,cunit
        endif        
        icount=icount+1
        if(iflg(icount).eq.1) then
         iii=iii+1
         do k=1,nblk
          do ich=1,nch
          if(abs(y(k,ich)).gt.1.e5) then
           write(6,*)' Overflow! Use bigger scale factor.'
           stop
     	  endif
          enddo
         enddo
         do k=1,nblk
          t=tst+real(k-1)*dt1
          write(2,cform3)k,t,(q(k,ich),ich=1,nch)             ! jun14
         enddo
        else
c        write(6,*)
c    *   ' A block is skipped at i_mea=',i_mea,' and iblk=',iblk
        endif
c end of do loop over iblk
       enddo
c end of do loop over i_mea
      enddo
      write(6,*)
     *' Second screening ({rms-average(rms)}/sigma<',a_sgm,'):'
      write(6,*)mmblk,' blocks remained among ',mmblk0,' blocks'
      close(12)
      close(2)
      close(10)
c
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2,cform3,cform4)
      character cform1*15,cform2*20,cform3*18,cform4*18
      if(nch.ge.10) then
       write(cform1,'(a4,i2,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,10x)')'(2i4,f8.2)' 
       write(cform3,'(a10,i2,a6)')'(i8,f16.4,',nch,'e15.7)'
       write(cform4,'(a10,i2,a6)')'(8x,f16.4,',nch,'e15.7)'
      else if(nch.ge.2) then
       write(cform1,'(a4,1x,i1,a9)')'(1x,',nch,'(a12,1x))'
       write(cform2,'(a10,10x)')'(2i4,f8.2)'
       write(cform3,'(a10,1x,i1,a6)')'(i8,f16.4,',nch,'e15.7)'
       write(cform4,'(a10,1x,i1,a6)')'(8x,f16.4,',nch,'e15.7)'
      else
       write(6,*)'nch should be bigger than 1!'
      endif
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c
      ntaper=min(real(n)/20.,20./dt)  
      do i=1,ntaper+1
       x(i)=x(i)*real(i-1)/real(ntaper)
      enddo         
      return
      end
c+++++
