      program seeblk1
      parameter(nmax0=1200000,nch0=15,mblk0=3000) 
      character filen*80,filem*80,comment*50,cform9*18
      real*4 x(nmax0,nch0),xx(nmax0),amaxacc(nch0,mblk0),
     +       xdum(nmax0),axmx(mblk0)
      character cdrv*10,cwkf*80,cform*5,cunit*5
      data aym,x0,yl,DTL/42.0,0.0,2.0,5.0/ 
      data cdrv/'./spacwkf/'/ 
      data eps/1.e-3/ pai/3.141592/
c working folder name
      cwkf=cdrv//'prm/'
      data fl,fh,fs/0.1,1.5,2.0/ 
c Chebishev I(2), Lowpass (2) Bandpass(3), Causal(1)
      data ap,as/0.1,10./ ntype,nchara0,ncausal/2,3,1/
c
      filen=cwkf(1:14)//'seeblk1.prm'
      write(6,*)filen
      open(11,file=filen,status='old')
      read(11,*)nbandp,fl,fh,fs,nchara
      read(11,*)n_mea,ncharacter
      if(ncharacter.le.9) then
       write(cform,'(a2,i1,a1)')'(a',ncharacter,')'
      else
       write(cform,'(a2,i2,a1)')'(a',ncharacter,')'
      endif
c
      do i_mea=1,n_mea
       cwkf=cdrv//'data/resampled_files/'
       read(11,cform)filem
       filen=cwkf(1:31)//filem(1:ncharacter)
       write(6,*)filen
       open(12,file=filen,status='old')
       read(12,'(3i8,2x,a18,1x,a5)')nch,mblk,nn,cform9,cunit
c
       if(nch.le.7) then 
	fac=0.65
	aym=42. 
       else if(nch.eq.8) then
	fac=0.55
	aym=48.
       else if(nch.eq.9) then
	fac=0.5
	aym=54.
       else if(nch.eq.10) then
	fac=0.45
	aym=60.
       else if(nch.eq.11) then
	fac=0.4
	aym=66.
       else if(nch.eq.12) then
	fac=0.35
	aym=66.
       else if(nch.eq.13) then
	fac=0.3
	aym=66.
       else if(nch.eq.14) then
	fac=0.25
	aym=66.
       else if(nch.eq.15) then
	fac=0.2
	aym=66.
       else if(nch.ge.16) then
	write(6,*)'Nch>15 is not available.'
        stop
       endif
       read(12,*)idum,t1
       read(12,*)idum,t2
       dt=t2-t1
       backspace(12)
       backspace(12)
       td=real(nn)*dt
c time blocks
       nmax=mblk*nn
       do iblk=1,mblk
c       if(mod(iblk,10).eq.0) write(6,*) mblk,iblk
c read input data
        do i=1,nn
         ii=i+(iblk-1)*nn
         read(12,cform9) idum,t,(x(ii,ich),ich=1,nch)
c        write(6,cform9) idum,t,(x(ii,ich),ich=1,nch)
        enddo
       enddo                      ! loop on iblk
       close(12)
c
      if(nbandp.eq.1) then
       write(6,*)' DC-offset removed & tapered;'
       nnave=nn/20
       do iblk=1,mblk
        do ich=1,nch
         sum=0.0
         do i=1,nnave
          ii=i+(iblk-1)*nn
          sum=sum+x(ii,ich)
         enddo
         ave=sum/real(nnave)
         do i=1,nn
          ii=i+(iblk-1)*nn
          x(ii,ich)=x(ii,ich)-ave
         enddo
         do i=nst,nnave
          ii=i+(iblk-1)*nn
          x(ii,ich)=x(ii,ich)*real(i)/real(nnave)
         enddo
        enddo
       enddo
c
       if(fs.lt.0.5/dt) then
	if(nchara.eq.2) then
         write(6,*)'fs<f(nyquist), lowpass filter applied;'
	else if(nchara.eq.3) then
         write(6,*)'fs<f(nyquist), bandpass filter applied;'
        endif
        do iblk=1,mblk
         do ich=1,nch
          do i=1,nn
           ii=i+(iblk-1)*nn
           xx(i)=x(ii,ich)
          enddo
         call bandp1(xx,nn,dt,fl,fh,fs,ap,as,ntype,nchara,ncausal)
          do i=1,nn
           ii=i+(iblk-1)*nn
           x(ii,ich)=xx(i)
          enddo
         enddo
        enddo
       else
	write(6,*)'fs>f(nyquist), bandpass filter NOT applied;'
       endif
      endif                      ! if block on nbandp
c      
      do iblk=1,mblk
       do ich=1,nch
        amaxacc(ich,iblk)=abs(x(1+(iblk-1)*nn,ich))
        do i=2+(iblk-1)*nn,iblk*nn
         if(amaxacc(ich,iblk).lt.abs(x(i,ich))) then
          amaxacc(ich,iblk)=abs(x(i,ich))
         endif
        enddo
c       write(6,*)amaxacc(ich,iblk)
       enddo
c
       amaxx=amaxacc(1,iblk)
       do ich=2,nch
        if(amaxx.lt.amaxacc(ich,iblk)) amaxx=amaxacc(ich,iblk)
       enddo
c
       xxmax=100000.
       if(amaxx.lt.50000.) xxmax=50000.
       if(amaxx.lt.20000.) xxmax=20000.
       if(amaxx.lt.10000.) xxmax=10000.
       if(amaxx.lt.5000.) xxmax=5000.
       if(amaxx.lt.2000.) xxmax=2000.
       if(amaxx.lt.1000.) xxmax=1000.
       if(amaxx.lt. 500.) xxmax= 500.
       if(amaxx.lt. 200.) xxmax= 200.
       if(amaxx.lt. 100.) xxmax= 100.
       if(amaxx.lt.  50.) xxmax=  50.
       if(amaxx.lt.  20.) xxmax=  20.
       if(amaxx.lt.  10.) xxmax=  10.
       if(amaxx.lt.   5.) xxmax=   5.
       if(amaxx.lt.   2.) xxmax=   2.
       if(amaxx.lt.   1.) xxmax=   1.
       if(amaxx.lt.   .5) xxmax=    .5
       if(amaxx.lt.   .2) xxmax=    .2
       if(amaxx.lt.   .1) xxmax=    .1
       if(amaxx.lt.   .05) xxmax=   .05
       if(amaxx.lt.   .02) xxmax=   .02
       if(amaxx.lt.   .01) xxmax=   .01
       if(amaxx.lt.   .005) xxmax=  .005
       if(amaxx.lt.   .002) xxmax=  .002
       if(amaxx.lt.   .001) xxmax=  .001
       if(amaxx.lt.   .0005) xxmax= .0005
       if(amaxx.lt.   .0002) xxmax= .0002
       if(amaxx.lt.   .0001) xxmax= .0001
       if(amaxx.lt.   .00005) xxmax=.00005
       if(amaxx.lt.   .00002) xxmax=.00002
       if(amaxx.lt.   .00001) xxmax=.00001
       axmx(iblk)=xxmax
      enddo
c
      do ichara=1,12
       if(filem(ichara:ichara).eq.'.') then
        nnchara=ichara-1
       endif
      enddo
      nunit=nn                           ! samples in one page
      dtl=real(int(td/28.)+1)            ! time/cm in horizontal axis
      cwkf=cdrv//'data/results/fig_wave/'
      filen=cwkf(1:32)//filem(1:nnchara)//'.ps'
      write(6,'(a)') filen
      open(25,file=filen,status='unknown')
ccccc
      n_page=0
      do iblk=1,mblk
       n_page=n_page+1
       CALL PLOTS(25)
c      call yoko(25) 
       CALL FACTOR(FAC)
       call plot(x0,0.,-3)
       CALL NEWPEN(1)
       ay=aym
       ndatamax=nn
c      write(6,*)ndatamax
       if(ndatamax.lt.nmax) call symbol(28.,0.5,0.3,'C',0.0,1)
       do ich=1,nch
        call symbol(4.0,ay+yl+0.3,0.3,'Max=',0.0,4)
        call number(5.5,ay+yl+0.3,0.3,amaxacc(ich,iblk),0.0,3)
        call symbol(7.5,ay+yl+0.3,0.3,cunit,0.0,5)
c       call number(9.3,ay+yl+0.3,0.3,scale,0.0,1)
        do i=1,nn
         xx(i)=x(nunit*(n_page-1)+i,ich)
        enddo
        CALL PLOT( 2., AY,-3)
        call pltwv2(xx,ndatamax,dt,dtl,axmx(iblk),yl,4)
        CALL PLOT(-2.,-AY,-3)
        ay=ay-3.*yl
       enddo
       if(n_page.eq.1) then
        write(filen,'(a12,i2,a8)')filem,n_page,'-st page'
       else if(n_page.eq.2) then
        write(filen,'(a12,i2,a8)')filem,n_page,'-nd page'
       else if(n_page.eq.3) then
        write(filen,'(a12,i2,a8)')filem,n_page,'-rd page'
       else
        write(filen,'(a12,i2,a8)')filem,n_page,'-th page'
       endif
       call symbol(12.0,ay+0.5,1.0,filen,0.0,22)     
       call plote(25)
c
       enddo                      ! loop on iblk
       close(25)
c
      enddo                       ! loop on i_mea
c
      stop
      end
c
      include 'dgflt.f'
      include 'pltwv2.for'
      include 'PSCAL.F'
c
