      Program zcorrel5_3
c caluculate the followings for multichannel microremor data
c multi-dataset version
c  1. cross-spectra 
c  2. block averaging
c  3. Parzen window
c  4. normilized cross spectra
c  5. Average over azimuth
c Standard Deviation of SPAC coeff. is calculated from that of Block Averaging
c 
c                     copyright Toshiaki. Yokoi, IISEE, BRI, Japan Sep 14, 2005
c
c zcorrel5_2 ==> zcorrel5_3  by Toshiaki Yokoi, IISEE, BRI, Japan June 11,2016
c modified for vel/acc input by Toshiaki Yokoi, IISEE, BRI, Japan June 18,2016
      parameter(nn0=8192,nmax=nn0,nch0=11,ij00=nch0*(nch0+1)/2,
     *                            mblk0=1000,lmax0=1024,nrad=20)
      complex cf(nn0),cg(nn0),crr(nn0,nch0**2),cr_sum,cr_ave,c0,
     * 	    cr(nn0,nch0**2),sd(nn0,nch0**2),
     *	    cr0(nn0,nch0**2),sd0(nn0,nch0**2),
     *	    cv(nn0,nch0,nch0),cv0(nn0,nch0,nch0),
     *        cz,cr1(nn0,nrad),sd1(nn0,nrad),
     *        coh0(nn0,nch0**2),soh0(nn0,nch0**2), 
     *        cof(nn0,nch0**2),sof(nn0,nch0**2), 
     *        coh1(nn0,nch0**2),soh1(nn0,nch0**2)
      real    x(nn0,nch0),f(nn0),g(nn0),fr(nn0),w(lmax0),
     *        h(nn0),g1(nn0**2),g2(nn0**2),rr(nrad),
     *        frmi(nrad),frma(nrad),au(nn0,nch0**2),au0(nn0,nch0**2),
     *        bu(nn0,nch0**2),bu0(nn0,nch0**2)
      integer nf(nch0**2),ng(nch0**2),kk(nch0),nm(nrad),
     *        nfp(nch0),ngp(nch0),nij(nch0**2)
      character filen*80,cline(3)*80,cpair(10,nrad)*2,
     *        cdummy*120,fileo*10,filep*10,finput*12,cunit*5,
     *        cform1*24,cform2*21,cform3*30,cform4*21,cform9*18
      character cdrv*10,cwkf*80
      data cdrv/'./spacwkf/'/ 
      data c0,eps/(0.,0.),1.e-3/ pai/3.141592/
c flag to select real(=0) or imaginary(=1) part of CCF for output
      data n_re_im/0/
c
      write(6,*)'Program zcorrel5_3.for'
c working folder name
      cwkf=cdrv//'prm/'
      open(20,status='scratch')
c parameter file
      filen=cwkf(1:14)//'zcorrel5_3.prm'
      write(6,*)filen
      open(11,file=filen,status='old')
      read(11,*)                           ! comment line
      read(11,*)fmin,fmax,dt,bw,n_huddle,nhide
c
      if(n_huddle.eq.0) then
       read(11,*)
       go to 100
      endif
c
c read huddle test file
c
c file name for huddle test
      read(11,*) finput,n_coh,n_pow
      cwkf=cdrv//'data/resampled_files/'
      filen=cwkf(1:31)//finput
      write(6,*)finput,filen,n_coh,n_pow
      open(12,file=filen,status='old')
      read(12,'(3i8,2x,a18,1x,a5)')
     +                      nch,mblk,nn_org,cform9,cunit
      if(cunit.eq.'mkine') scale=1.e-5   ! mkine to M/s
      if(cunit.eq.'gal'.or.cunit.eq.'gal  ') scale=1.e-3 ! gal to M/s^2
      write(6,*)nch,mblk,nn_org
      if(nn.gt.nn0) then
       write(6,*)'block size of the input file is bigger than 
     *                              that used in the program.'
       stop
      endif
      read(12,*)idum,t1
      read(12,*)idum,t2
      dt1=t2-t1
      backspace(12)
      backspace(12)
      if(abs(dt-dt1).ge.eps) then
       write(6,*)' dt does not coincide.',dt,dt1,dt-dt1
       stop
      else
       dt=dt1
      endif      
c duration and frequency
ccc
      nn=nn_org*nhide               ! it is expected that nn=<1024
  132 continue 
      if(nn.gt.nn0) then
       nn=nn/2
       go to 132
      endif
      write(6,'(a4,i6)')' nn=',nn
ccc
      td=real(nn)*dt
      if(bw.le.3.71/td) then
       if(bw.gt.1.e-5) then
       write(6,*)' bw is too small, use bigger than',3.71/td
       stop
       else
        write(6,*)' bw=0.0. Parzen window not applied.'
       endif
      endif
      do i=1,nn
       fr(i)=real(i-1)/td
      enddo
      do i=2,nn
       if(fr(i).ge.fmin) then
        isf=i
        go to 6
       endif
      enddo
    6 continue  !  write(6,*) isf,fr(isf)
      do i=nn/2-1,2,-1
       if(fr(i).le.fmax) then
        ief=i
        go to 8
       endif
      enddo
    8 continue  !  write(6,*) ief,fr(ief)
c calculate power & cross spectra of field data file
      do iblk=1,mblk
       if(mod(iblk,10).eq.0) then
        write(6,*) mblk,iblk
       endif
c read input data
       do i=1,nn_org
        read(12,cform9) idum,t,(x(i,ich),ich=1,nch)
       enddo
c 
       ij=0
       do ii=1,nch
        do jj=ii,nch
         ij=ij+1
         nf(ij)=ii
         do i=1,nn_org
          f(i)=x(i,ii)
         enddo
         call taper(f,nn_org,dt)
c zero padding
       do i=nn_org+1,nn
        do ich=1,nch
         f(i)=0.0
        enddo
       enddo
c
         do i=1,nn
          cf(i)=cmplx(f(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cf,nn,-1)
         do i=1,isf-1
          cf(i)=c0
         enddo
         do i=isf,ief
          cf(i)=cf(i)/real(nn)
         enddo
         do i=ief+1,nn
          cf(i)=c0
         enddo
c
         ng(ij)=jj
         do i=1,nn_org
          g(i)=x(i,jj)
         enddo
         call taper(g,nn_org,dt)
c zero padding
         do i=nn_org+1,nn
          do ich=1,nch
           g(i)=0.0
          enddo
         enddo
c
         do i=1,nn
          cg(i)=cmplx(g(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cg,nn,-1)
         do i=1,isf-1
          cg(1)=c0
         enddo
         do i=isf,ief
          cg(i)=cg(i)/real(nn)
         enddo
         do i=ief+1,nn
          cg(i)=c0
         enddo
c cross-correlation of cf(i) and cg(i) in the frequency domain
         do i=1,nn
          cf(i)=cf(i)*conjg(cg(i))
         enddo 
c parzen window
         if(bw.gt.1.e-5) then
         do i=1,nn
          f(i)= real(cf(i))
          g(i)=aimag(cf(i))
         enddo
         call w_parzen(f,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
         call w_parzen(g,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
         do i=isf,ief
          cf(i)=cmplx(f(i),g(i))
         enddo
         endif
c
         do i=isf,ief
          write(20,*)iblk,ij,i,cf(i)	
         enddo
        enddo
       enddo
       ij0=ij
      enddo
      close(12)
      rewind(20)
c auto and cross spectra and their variance
      write(6,*)
     * ' power and cross spectra for huddle test data calculated.'
c average
      do ij=1,ij0
       do i=1,nn
        cr0(i,ij)=c0
        cof(i,ij)=c0
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=isf,ief
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          write(6,*)i,i_dum,ij,ij_dum,iblk,iblk_dum
          stop
         endif
         cr0(i,ij)=cr0(i,ij)+crr(i,ij)
        enddo
       enddo
       do i=isf,ief
        do ij=2,ij0
         cof(i,ij)=cof(i,ij)+real(crr(i,1))/crr(i,ij)
        enddo
        cof(i,1)=cof(i,1)+(1.,0.)
       enddo
      enddo
c average of cross spectra
      do ij=1,ij0
       do i=isf,ief
        cr0(i,ij)=cr0(i,ij)/real(mblk)
        cof(i,ij)=cof(i,ij)/real(mblk)
       enddo
      enddo
c
      ij=0
      do ii=1,nch
       do jj=ii,nch
        ij=ij+1
        if(ii.eq.jj) then
         kk(nf(ij))=ij
        endif
       enddo
      enddo
c variance
      rewind(20)
      do i=1,nn
       do ij=1,ij0
        sd0(i,ij)=c0
        au0(i,ij)=0.
        bu0(i,ij)=0.
       enddo
       do ich=1,nch
        do jch=1,nch
	   cv0(i,ich,jch)=c0
        enddo
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=isf,ief
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
c variance of power & cross spectra
         sd0(i,ij)=sd0(i,ij)
     *            +cmplx(( real(crr(i,ij))- real(cr0(i,ij)))**2,
     *                   (aimag(crr(i,ij))-aimag(cr0(i,ij)))**2)
c variance of correction factor cof(k,ij)
         if(ij.eq.1) then
          sof(i,ij)=c0
         else
          cr_ave=real(crr(i,1))/crr(i,ij)
          sof(i,ij)=sof(i,ij)+cmplx(( real(cr_ave)- real(cof(i,ij)))**2,
     *                              (aimag(cr_ave)-aimag(cof(i,ij)))**2)
         endif
c covariance between real & imaginary parts of cross spectra
         bu0(i,ij)=bu0(i,ij)+real(crr(i,ij)-cr0(i,ij))*
     *                      aimag(crr(i,ij)-cr0(i,ij))
        enddo
       enddo
       do ij=1,ij0
        ii=nf(ij)
	  jj=ng(ij)
        ki=kk(ii)
        kj=kk(jj)
        if(nf(ij).ne.ng(ij)) then
         do i=isf,ief
c covariance between different channel of power spectra
          au0(i,ij)=au0(i,ij)+real(crr(i,ki)-cr0(i,ki))*
     *                        real(crr(i,kj)-cr0(i,kj))
c covariance between power spectra & cross spectra
          cv0(i,ii,jj)=cv0(i,ii,jj)+cmplx(
     *    real(crr(i,ki)-cr0(i,ki))* real(crr(i,ij)-cr0(i,ij)),
     *    real(crr(i,ki)-cr0(i,ki))*aimag(crr(i,ij)-cr0(i,ij)))
          cv0(i,jj,ii)=cv0(i,jj,ii)+cmplx(
     *    real(crr(i,kj)-cr0(i,kj))* real(crr(i,ij)-cr0(i,ij)),
     *    real(crr(i,kj)-cr0(i,kj))*aimag(crr(i,ij)-cr0(i,ij)))
         enddo
        endif
       enddo
      enddo
      do ij=1,ij0
       do i=isf,ief
        sd0(i,ij)=sd0(i,ij)/real(mblk)
        au0(i,ij)=au0(i,ij)/real(mblk)
        bu0(i,ij)=bu0(i,ij)/real(mblk)
       enddo
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         cv0(i,nf(ij),ng(ij))=cv0(i,nf(ij),ng(ij))/real(mblk)
         cv0(i,ng(ij),nf(ij))=cv0(i,ng(ij),nf(ij))/real(mblk)
        enddo
       endif
      enddo
      rewind(20)
      write(6,*)'Block Averaging has been done.'
c format controller
      call formatter(nch,cform1,cform2,cform3,cform4)
c power spectra output
      if(n_pow.ne.0) then
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//finput(1:6)//'_psp.dat'
       write(6,*)filen,'Power Spectra Output for Huddle Test:',filen 
       open(2,file=filen,status='unknown')
       if(n_pow.eq.1) then
        write(2,cform1)'# Period', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
        do k=ief,isf,-1 
         if(cunit.eq.'mkine') then   ! velocity input
          aaa=td*(2.*pai*fr(k))**2
         else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
          aaa=td
         endif
         write(2,cform2)1./fr(k),
     *    (10*LOG10(real(cr0(k,kk(ich)))*aaa),ich=1,nch),
     *    (10*LOG10(sqrt(real(sd0(k,kk(ich))))*aaa),ich=1,nch)
	  enddo
c	write(6,*)cform1,cform2
       else if(n_pow.eq.2) then
        write(2,'(a8,10(7x,i1,a1,i1,a2,12x))')
     *     '   Freq.',(nf(ij),'-',ng(ij),'ch',ij=1,ij0)
        do k=isf,ief 
         write(2,'(f8.6,20e12.5)')
     *     fr(k),(real(cr0(k,ij)),imag(cr0(k,ij)),ij=1,ij0)
	  enddo
 	  stop
	 endif
       close(2)
      endif
c
      do ij=1,ij0
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         xx=cabs(cr0(i,kk(nf(ij))))
         yy=cabs(cr0(i,kk(ng(ij))))
         cz=cr0(i,ij)
c complex coherence function
         coh0(i,ij)=cz/sqrt(xx*yy)
c variance
         sxx=real(sd0(i,kk(nf(ij))))/xx**2
         syy=real(sd0(i,kk(ng(ij))))/yy**2
         sxy=au0(i,ij)/(xx*yy)
         zz=real(cz)
         sxz=real(cv0(i,nf(ij),ng(ij)))/(xx*zz)
         syz=real(cv0(i,ng(ij),nf(ij)))/(yy*zz)
         szz=real(sd0(i,ij))/zz**2
         f2=real(coh0(i,ij))**2
         sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxr.lt.0.) sxr=abs(sxr)
         zz=aimag(cz)
         sxz=aimag(cv0(i,nf(ij),ng(ij)))/(xx*zz)
         syz=aimag(cv0(i,ng(ij),nf(ij)))/(yy*zz)
         szz=aimag(sd0(i,ij))/zz**2
         f2=aimag(coh0(i,ij))**2
         sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxi.lt.0) sxi=abs(sxi)
         soh0(i,ij)=cmplx(sxr,sxi)
        enddo
       endif
      enddo
c coherence output
      if(n_coh.ne.0) then
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//finput(1:6)//'_coh.dat'
       write(6,*)filen,' Coherence Output for Huddle Test.' 
       open(2,file=filen,status='unknown')
       write(2,cform3)
     *  '#  Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
       do k=isf,ief
        id=0
        do ij=1,ij0
         if(nf(ij).lt.ng(ij)) then
          id=id+1
          f(id)=real(coh0(k,ij))
          g(id)=sqrt(real(soh0(k,ij)))
         endif
        enddo
        id0=id
        write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
       enddo
       close(2)
      endif
c
  100 continue
      if(n_huddle.eq.0) then
       write(6,*)' Huddle Test Skipped.'
      else
       write(6,*)' Correction using Huddle Test Data is conducted.'
      endif
c
c read field data file
c
c
      read(11,*) finput,n_coh,n_pow
      cwkf=cdrv//'data/resampled_files/'
      filen=cwkf(1:31)//finput
      open(12,file=filen,status='old')
      read(12,'(3i8,2x,a18,1x,a5)')
     +                     nch,mblk,nn_org,cform9,cunit
      if(cunit.eq.'mkine') scale=1.e-5  !  mkine to M/s
      if(cunit.eq.'gal'.or.cunit.eq.'gal  ') scale=1.e-3 ! gal to M/s^2
      if(nn_org.gt.nn0) then
       write(6,*)'block size of the input file is bigger than 
     *                              that used in the program.'
       stop
      endif
      read(12,*)idum,t1
      read(12,*)idum,t2
      dt1=t2-t1
      backspace(12)
      backspace(12)
      if(abs(dt-dt1).ge.eps) then
       write(6,*)' dt does not coincide.',dt,dt1,dt-dt1
       stop
      else
       dt=dt1
      endif      
c duration and frequency
ccc
      nn=nn_org*nhide               ! it is expected that nn=<1024
  142 continue 
      if(nn.gt.nn0) then
       nn=nn/2
       go to 142
      endif
      write(6,'(a4,i6)')' nn=',nn
ccc
      td=real(nn)*dt
      if(bw.le.3.71/td) then
       if(bw.gt.1.e-5) then
       write(6,*)' bw is too small, use bigger than',3.71/td
       stop
       else
        write(6,*)' bw=0.0. Parzen window not applied.'
       endif
      endif
      do i=1,nn
       fr(i)=real(i-1)/td
      enddo
      do i=2,nn
       if(fr(i).ge.fmin) then
        isf=i
        go to 106
       endif
      enddo
  106 continue  !  write(6,*) isf,fr(isf)
      do i=nn/2-1,2,-1
       if(fr(i).le.fmax) then
        ief=i
        go to 108
       endif
      enddo
  108 continue  !  write(6,*) ief,fr(ief)
c calculate power & cross spectra of field data file
      do iblk=1,mblk
       if(mod(iblk,10).eq.0) write(6,*) mblk,iblk
c read input data
       do i=1,nn_org
        read(12,cform9) idum,t,(x(i,ich),ich=1,nch)
       enddo
c 
       ij=0
       do ii=1,nch
        do jj=ii,nch
	   ij=ij+1
	   nf(ij)=ii
	   do i=1,nn_org
	    f(i)=x(i,ii)
 	   enddo
         call taper(f,nn_org,dt)
c zero padding
         do i=nn_org+1,nn
          do ich=1,nch
           f(i)=0.0
          enddo
         enddo
c
         do i=1,nn
          cf(i)=cmplx(f(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cf,nn,-1)
         do i=1,isf-1
          cf(i)=c0
         enddo
         do i=isf,ief
          cf(i)=cf(i)/real(nn)
         enddo
         do i=ief+1,nn
          cf(i)=c0
         enddo
c
         ng(ij)=jj
         do i=1,nn_org
          g(i)=x(i,jj)
         enddo
         call taper(g,nn_org,dt)
c zero padding
         do i=nn_org+1,nn
          do ich=1,nch
           g(i)=0.0
          enddo
         enddo
c
         do i=1,nn
          cg(i)=cmplx(g(i)*scale,0.0)
         enddo
c Fourier Transform
         call cfft(cg,nn,-1)
         do i=1,isf-1
          cg(i)=c0
         enddo
         do i=isf,ief
          cg(i)=cg(i)/real(nn)
         enddo
         do i=ief+1,nn
          cg(i)=c0
         enddo
c cross-correlation of cf(i) and cg(i) in the frequency domain
         do i=1,nn
          cf(i)=cf(i)*conjg(cg(i))	
c         write(6,*)iblk,ii,jj,i,cf(i)
         enddo
c parzen window
         if(bw.gt.1.e-5) then
         do i=1,nn
          f(i)= real(cf(i))
          g(i)=aimag(cf(i))
         enddo
         call w_parzen(f,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
         call w_parzen(g,nn,nmax,dt,bw,g1,g2,nmax*2,w,lmax0)
         do i=1,nn
          cf(i)=cmplx(f(i),g(i))
         enddo
         endif
c
         do i=isf,ief
          write(20,*)iblk,ij,i,cf(i)	
c         write(6,*)iblk,ij,i,cf(i)	
         enddo
        enddo
       enddo
       ij0=ij
      enddo
      close(12)
      rewind(20)
c auto and cross spectra and their variance
      write(6,*)' power and cross spectra for field data calculated.'
c average
      do ij=1,ij0
       do i=1,nn
        crr(i,ij)=c0
       enddo
      enddo
      do iblk=1,mblk
       do ij=1,ij0
        do i=isf,ief
         read(20,*)iblk_dum,ij_dum,i_dum,cr_ave
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
         crr(i,ij)=crr(i,ij)+cr_ave
        enddo
       enddo
      enddo
      do ij=1,ij0
       do i=isf,ief
        cr(i,ij)=crr(i,ij)/real(mblk)
c       write(6,*)cr(i,ij)
       enddo
      enddo
c
      ij=0
      do ii=1,nch
       do jj=ii,nch
        ij=ij+1
        if(ii.eq.jj) then
         kk(nf(ij))=ij
        endif
       enddo
      enddo
c variance
      rewind(20)
      do i=1,nn
       do ij=1,ij0
        sd(i,ij)=c0
        au(i,ij)=0.
        bu(i,ij)=0.
       enddo
       do ich=1,nch
        do jch=1,nch
         cv(i,ich,jch)=c0
        enddo
       enddo
      enddo
c
      do iblk=1,mblk
       do ij=1,ij0
        do i=isf,ief
         read(20,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
c        write(6,*)iblk_dum,ij_dum,i_dum,crr(i,ij)
         if(i.ne.i_dum.or.ij.ne.ij_dum.or.iblk.ne.iblk_dum) then
          write(6,*) ' Error in reading temporary file!'
          stop
         endif
         sd(i,ij)=sd(i,ij)+cmplx((real(crr(i,ij))- real(cr(i,ij)))**2,
     *                          (aimag(crr(i,ij))-aimag(cr(i,ij)))**2)
c covariance between real & imaginary parts of cross spectra
         bu(i,ij)=bu(i,ij)+ real(crr(i,ij)-cr0(i,ij))*
     *                                       aimag(crr(i,ij)-cr0(i,ij))
        enddo
       enddo
       do ij=1,ij0
        ii=nf(ij)
        jj=ng(ij)
        ki=kk(ii)
        kj=kk(jj)
        if(nf(ij).ne.ng(ij)) then
         do i=isf,ief
c covariance between different channel of power spectra
          au(i,ij)=au(i,ij)+real(crr(i,ki)-cr(i,ki))*
     *                      real(crr(i,kj)-cr(i,kj))
c covariance between power spectra & cross spectra
          cv(i,ii,jj)=cv(i,ii,jj)+cmplx(
     *    real(crr(i,ki)-cr(i,ki))* real(crr(i,ij)-cr(i,ij)),
     *    real(crr(i,ki)-cr(i,ki))*aimag(crr(i,ij)-cr(i,ij)))
          cv(i,jj,ii)=cv(i,jj,ii)+cmplx(
     *    real(crr(i,kj)-cr(i,kj))* real(crr(i,ij)-cr(i,ij)),
     *    real(crr(i,kj)-cr(i,kj))*aimag(crr(i,ij)-cr(i,ij)))
         enddo
        endif
       enddo
      enddo
      do ij=1,ij0
       do i=isf,ief
        sd(i,ij)=sd(i,ij)/real(mblk)
        au(i,ij)=au(i,ij)/real(mblk)
        bu(i,ij)=bu(i,ij)/real(mblk)
       enddo
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         cv(i,nf(ij),ng(ij))=cv(i,nf(ij),ng(ij))/real(mblk)
         cv(i,ng(ij),nf(ij))=cv(i,ng(ij),nf(ij))/real(mblk)
        enddo
       endif
      enddo
      rewind(20)
      write(6,*)'Block Averaging has been done.'
c format controller
      call formatter(nch,cform1,cform2,cform3,cform4)
c power spectra output
      if(n_pow.ne.0) then
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//finput(1:6)//'_psp.dat'
       write(6,*)filen,'Power Spectra Output:',filen 
       open(2,file=filen,status='unknown')
       write(2,cform1)'# Period', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
       do k=ief,isf,-1 
        if(cunit.eq.'mkine') then   ! velocity input
         aaa=td*(2.*pai*fr(k))**2
        else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
         aaa=td
        endif
        write(2,cform2)1./fr(k),
     *   (10*LOG10(real(cr(k,kk(ich)))*aaa),ich=1,nch),
     *   (10*LOG10(sqrt(real(sd(k,kk(ich))))*aaa),ich=1,nch)
       enddo
       close(2)
      endif
c
      do ij=1,ij0
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         xx=cabs(cr(i,kk(nf(ij))))
         yy=cabs(cr(i,kk(ng(ij))))
         cz=cr(i,ij)
c complex coherence function
c      write(6,*)'check point 0',kk(nf(ij)),xx,kk(ng(ij)),yy
         coh1(i,ij)=cz/sqrt(xx*yy)
c variance
         sxx=real(sd(i,kk(nf(ij))))/xx**2
         syy=real(sd(i,kk(ng(ij))))/yy**2
         sxy=au(i,ij)/(xx*yy)
         zz=real(cz)
         sxz=real(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=real(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=real(sd(i,ij))/zz**2
         f2=real(coh1(i,ij))**2
         sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
c        if(sxr.lt.0.) write(6,*)i,ij,sxr
         if(sxr.lt.0.) sxr=abs(sxr)
         zz=aimag(cz)
         sxz=aimag(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=aimag(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=aimag(sd(i,ij))/zz**2
         f2=aimag(coh1(i,ij))**2
         sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxi.lt.0) sxi=abs(sxi)
         soh1(i,ij)=cmplx(sxr,sxi)
        enddo
       endif
      enddo
c coherence output
      if(n_coh.ne.0) then
       cwkf=cdrv//'data/results/'
       filen=cwkf(1:23)//finput(1:6)//'_coh.dat'
       write(6,*)filen,' Coherence Output' 
       open(2,file=filen,status='unknown')
       write(2,cform3)
     *  '#  Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
       do k=isf,ief
        id=0
        do ij=1,ij0
         if(nf(ij).lt.ng(ij)) then
          id=id+1
          f(id)=real(coh1(k,ij))
          g(id)=sqrt(real(soh1(k,ij)))
         endif
        enddo
        id0=id
        write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
       enddo
       close(2)
      endif
      close(20)
c correction for system characteristics using auto & cross spectra of haddle test file
c system characteristics of all channels are ajusted to those of the 1-ch
      if(n_huddle.ne.0) then
c variances & covariances
       do k=isf,ief
        do ij=1,ij0
c independent variables (ar,ai):correction factor
         aar = real(cof(k,ij))
         aar2=aar**2
         aai =aimag(cof(k,ij))
         aai2=aai**2
         sarr= real(sof(k,ij))
         saii=aimag(sof(k,ij))
         sari=bu0(k,ij)
c independent variables (br,bi):field data 
         abr = real(cr(k,ij))
         abr2=abr**2
	   abi =aimag(cr(k,ij))
         abi2=abi**2
         sbrr= real(sd(k,ij))
         sbii=aimag(sd(k,ij))
         sbri=bu(k,ij)
c combined variances of (Ar,Ai)*(Br,Bi)
         sxrr=abr2*sarr+abi2*saii-2.*abr*abi*sari
     *       +aar2*sbrr+aai2*sbii-2.*aar*aai*sbri
         sxii=abi2*sarr+abr2*saii+2.*abr*abi*sari
     *       +aai2*sbrr+aar2*sbii+2.*aar*aai*sbri
c Var(Cr), Var(Ci)
         sd(k,ij)=cmplx(sxrr,sxii)
c Covar(Cr, Ci) 
         bu(k,ij)=(abr2-abi2)*sari+(aar2-aai2)*sbri
c
         if(nf(ij).ne.ng(ij)) then
          ki=kk(nf(ij))
          kj=kk(ng(ij))
          aaki_r= real(cof(k,ki))
          aakj_r= real(cof(k,kj))
          abki_r= real( cr(k,ki))
          abkj_r= real( cr(k,kj))
c covariance between different channels of power spectra
          au(k,ij)=abki_r*abkj_r*au0(k,ij)+aaki_r*aakj_r* au(k,ij)
c covariance between power spectra and cross spectra
          aaki_i=aimag(cof(k,ki))
          aakj_i=aimag(cof(k,kj))
          abki_i=aimag( cr(k,ki))
          abkj_i=aimag( cr(k,kj))
c          aar= real(cof(k,ij))
c          aai=aimag(cof(k,ij))
c          abr= real( cr(k,ij))
c          abi=aimag( cr(k,ij))
          cr_ave=cv0(k,nf(ij),ng(ij))
          cr_sum= cv(k,nf(ij),ng(ij))
          sxr=abki_r*(abr*real(cr_ave)-abi*aimag(cr_ave))
     *       +aaki_r*(aar*real(cr_sum)-aai*aimag(cr_sum))       
          sxi=abki_r*(abi*real(cr_ave)+abr*aimag(cr_ave))
     *       +aaki_r*(aai*real(cr_sum)+aar*aimag(cr_sum))       
          cv(k,nf(ij),ng(ij))=cmplx(sxr,sxi)
          cr_ave=cv0(k,ng(ij),nf(ij))
          cr_sum= cv(k,ng(ij),nf(ij))
          sxr=abkj_r*(abr*real(cr_ave)-abi*aimag(cr_ave))
     *       +aakj_r*(aar*real(cr_sum)-aai*aimag(cr_sum))       
          sxi=abkj_r*(abi*real(cr_ave)+abr*aimag(cr_ave))
     *       +aakj_r*(aai*real(cr_sum)+aar*aimag(cr_sum))       
          cv(k,ng(ij),nf(ij))=cmplx(sxr,sxi)
         endif      
        enddo
       enddo
       do k=isf,ief
        do ij=1,ij0
         cr(k,ij)=cr(k,ij)*cof(k,ij)
        enddo
       enddo
       write(6,*)' Correction by huddle test done.'
c
c power spectra output
c
       if(n_pow.ne.0) then
        cwkf=cdrv//'data/results/'
        filen=cwkf(1:23)//finput(1:6)//'_cor_psp.dat'
        write(6,*)filen,'Corrected Power Spectra Output' 
        open(2,file=filen,status='unknown')
        write(2,cform1)'# Period', (ich,'-ch ',ich=1,nch),
     *              ' Power Spc', (ich,'-ch ',ich=1,nch),' S.D.     '
        do k=ief,isf,-1 
         if(cunit.eq.'mkine') then   ! velocity input
          aaa=td*(2.*pai*fr(k))**2
         else if(cunit.eq.'gal'.or.cunit.eq.'gal  ') then
          aaa=td
         endif
         write(2,cform2)1./fr(k),
     *    (10*LOG10(real(cr(k,kk(ich)))*aaa),ich=1,nch),
     *    (10*LOG10(sqrt(real(sd(k,kk(ich))))*aaa),ich=1,nch)
        enddo
        close(2)
       endif
c
c coherence
c
      do ij=1,ij0
       if(nf(ij).ne.ng(ij)) then
        do i=isf,ief
         xx=cabs(cr(i,kk(nf(ij))))
         yy=cabs(cr(i,kk(ng(ij))))
         cz=cr(i,ij)
c complex coherence function
         coh1(i,ij)=cz/sqrt(xx*yy)
c variance
         sxx=real(sd(i,kk(nf(ij))))/xx**2
         syy=real(sd(i,kk(ng(ij))))/yy**2
         sxy=au(i,ij)/(xx*yy)
         zz=real(cz)
         sxz=real(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=real(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=real(sd(i,ij))/zz**2
         f2=real(coh1(i,ij))**2
         sxr=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
c         if(sxr.lt.0.)  write(6,*)i,ij,sxr
         if(sxr.lt.0.) sxr=abs(sxr)
         zz=aimag(cz)
         sxz=aimag(cv(i,nf(ij),ng(ij)))/(xx*zz)
         syz=aimag(cv(i,ng(ij),nf(ij)))/(yy*zz)
         szz=aimag(sd(i,ij))/zz**2
         f2=aimag(coh1(i,ij))**2
         sxi=f2*((sxx+syy)/4.+szz+sxy/2.-sxz-syz)
         if(sxi.lt.0) sxi=abs(sxi)
         soh1(i,ij)=cmplx(sxr,sxi)
        enddo
       endif
      enddo
c
c coherence output
c
       if(n_coh.ne.0) then
        cwkf=cdrv//'data/results/'
        filen=cwkf(1:23)//finput(1:6)//'_cor_coh.dat'
        write(6,*)filen,' Corrected Coherence Output' 
        open(2,file=filen,status='unknown')
        write(2,cform3)
     *  '#  Freq.',  ((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' Coherence',((ii,'-',jj,'ch',jj=ii+1,nch),ii=1,nch),
     *  ' S.D.     '
c
        do k=isf,ief
         id=0
         do ij=1,ij0
          if(nf(ij).lt.ng(ij)) then
           id=id+1
           f(id)=real(coh1(k,ij))
           g(id)=sqrt(real(soh1(k,ij)))
          endif
         enddo
         id0=id
         write(2,cform4) fr(k),(f(id),id=1,id0),(g(id),id=1,id0)
        enddo
        close(2)
       endif
      endif
c
c
c
      read(11,*)m
      do im=1,m
       read(11,'(a80)')cline(1)
       read(cline(1),*)nm(im)
       read(cline(1),*)ndum,(cpair(ip,im),ip=1,nm(im)),rr(im)
      enddo
c
      do im=1,m
       do ip=1,nm(im)
        if(cpair(ip,im)(1:1).eq.'a') then
         nfp(ip)=11
        else if(cpair(ip,im)(1:1).eq.'b') then
         nfp(ip)=12
		else 
         read(cpair(ip,im)(1:1),'(i1)')nfp(ip)
        endif
        if(nfp(ip).eq.0) nfp(ip)=10
        if(cpair(ip,im)(2:2).eq.'a') then
         ngp(ip)=11
        else if(cpair(ip,im)(2:2).eq.'b') then
         ngp(ip)=12
        else
         read(cpair(ip,im)(2:2),'(i1)')ngp(ip)
        endif
        if(ngp(ip).eq.0) ngp(ip)=10
        ij=0
        do ii=1,nch
         do jj=ii,nch
          ij=ij+1
          if(ii.eq.nfp(ip).and.jj.eq.ngp(ip)) then
           nij(ip)=ij
          endif
         enddo
        enddo
       enddo
       do i=isf,ief
        cr_sum=c0
        do ip=1,nm(im)
         cr_sum=cr_sum+coh1(i,nij(ip))
        enddo
        cr_ave=cr_sum/real(nm(im))
        cr1(i,im)=cr_ave
        cr_sum=c0
        do ip=1,nm(im)
         cr_sum=cr_sum+soh1(i,nij(ip))
        enddo
        cr_ave=cr_sum/real(nm(im))**2
        sd1(i,im)=cmplx(sqrt(real(cr_ave)),sqrt(imag(cr_ave)))
       enddo
      enddo
c
      read(11,*)fileo
      cwkf=cdrv//'data/results/'
      filen=cwkf(1:23)//fileo 
      write(6,*)filen
      open(2,file=filen,status='unknown')
      write(cdummy,'(a10,i1,a10)')'(a1,I6,1x,',m,'(f7.1,a1))'
      if(m.ge.10.and.m.lt.100) then
       write(cdummy,'(a10,i2,a10)')'(a1,I6,1x,',m,'(f7.1,a1))'
      endif
      write(2,cdummy)'#',m,(rr(im),'m',im=1,m)
      do i=isf,ief
        if(m.lt.5) then
         write(cdummy,'(a1,i1,a5)')'(',m*2+1,'f8.3)'
        else if(m.lt.50) then
         write(cdummy,'(a1,i2,a5)')'(',m*2+1,'f8.3)'
        endif
        if(n_re_im.eq.0) then
         write(2,cdummy)fr(i),(real(cr1(i,im)),im=1,m),
     *                        (real(sd1(i,im)),im=1,m)
        else if(n_re_im.eq.1) then 
         write(2,cdummy)fr(i),(imag(cr1(i,im)),im=1,m),
     *                        (imag(sd1(i,im)),im=1,m)
        endif
      enddo
      close(2)
      close(11)
      stop
      end
c+++++
      subroutine formatter(nch,cform1,cform2,cform3,cform4)
      character cform1*24,cform2*21,cform3*30,cform4*21
      if(nch.ge.10) then
       write(cform1,'(a6,i2,a16)') '(a8,2(',nch,'(5x,i2,a3),a10))'
       write(cform2,'(a8,i2,a11)') '(f8.4,2(',nch,'f10.3,10x))'
      else if(nch.ge.2) then
       write(cform1,'(a6,1x,i1,a16)') '(a8,2(',nch,'(5x,i2,a3),a10))'
       write(cform2,'(a8,1x,i1,a11)') '(f8.4,2(',nch,'f10.3,10x))'
      else
       write(6,*)'nch should be begger than 1!'
      endif
c
      if(nch*(nch-1)/2.ge.10) then
       write(cform3,'(a6,i2,a22)') '(a8,2(',nch*(nch-1)/2  ,
     *                                     '(4x,i2,a1,i2,a2),a10))'
       write(cform4,'(a8,i2,a11)')'(f8.4,2(',nch*(nch-1)/2,
     *                                     'e11.3,10X))'
 
      else if(nch*(nch-1)/2.ge.1) then
       write(cform3,'(a6,1x,i1,a22)') '(a8,2(',nch*(nch-1)/2  
     *                                    ,'(4x,i2,a1,i2,a2),a10))'
       write(cform4,'(a8,1x,i1,a11)')'(f8.4,2(',nch*(nch-1)/2,
     *                                     'e11.3,10x))'
 
      endif
      end
c+++++
      subroutine peak_rms(x,n,judge,ac)
      real x(n)
c peak value
      amx=abs(x(1))
      do i=2,n
       if(amx.lt.abs(x(i))) amx=abs(x(i))
      enddo
c rms value
      sum=0.0
      do i=1,n
       sum=sum+x(i)**2
      enddo
      rms=sqrt(sum/real(n))
c judge
      judge=1
      if(amx.gt.rms*ac) judge=0
      return
      end
c+++++
      subroutine w_parzen(h,nn,n,dt,bw,g1,g2,n2,w,lmax0)
      real h(n),g1(n2),g2(n2),w(lmax0)
      data pai/3.141592/
c parzen window
      df=1./(dt*real(nn))
      udf=1.854305/bw*df
      if(udf.gt.0.5) then
       write(6,*)' Bandwidth is too narrow'
      endif
      lmax=int(2./udf+0.5)
      if(lmax.gt.lmax0) then
       write(6,*)'Bandwidth is too wide'
      endif
      w(1)=0.75*udf
      do l=2,lmax
       dif=pai/2.*real(l-1)*udf
       w(l)=w(1)*(sin(dif)/dif)**4
      enddo
      ll=lmax*2-1
      ln=ll-1+nn
      lt=(ll-1)*2+nn
      le=lt-lmax+1
      do k=1,lt
       g1(k)=0.
      enddo
      do k=1,nn
       g1(ll-1+k)=h(k)
      enddo
      do k=lmax,le
       s=w(1)*g1(k)
       do l=2,lmax
        s=s+w(l)*(g1(k-l+1)+g1(k+l-1))
       enddo
       g2(k)=s
      enddo
      do l=2,lmax
       g2(ll+l-1)=g2(ll+l-1)+g2(ll-l+1)
       g2(ln-l+1)=g2(ln-l+1)+g2(ln+l-1)
      enddo
      do k=1,nn
       h(k)=g2(ll-1+k)
      enddo
      return
      end
c+++++
      subroutine taper(x,n,dt)
      real x(n)
      data pai/3.141592/
      mwin=int(real(n)/20.+0.5)
c linear trend fitting
      b1=x(1)
      do i=2,n
       b1=b1+real(i)*x(i)
      enddo
      b2=x(1)
      do i=1,n
       b2=b2+x(i)
      enddo
      a0=real(n*(n+1)*(2*n+1))/6.*dt
      b0=real(n*(n+1))/2.
      c0=b0*dt
      d0=real(n)
      f0=a0*d0-b0*c0
      aa=( d0*b1-b0*b2)/f0
      bb=(-c0*b1+a0*b2)/f0
      do i=1,n
       x(i)=x(i)-aa*real(i)*dt-bb
      enddo
c tapering
      do i=1,mwin
       x(i)=x(i)*SIN(PAI/2.*REAL(i-1)/REAL(MWIN))
      enddo
      do i=n-mwin,n
       x(i)=x(i)*SIN(PAI/2.*REAL(n-i)/REAL(MWIN))
      enddo
      return
      end
c+++++
      SUBROUTINE CFFT(X,N,IND)
c...........................................................................
c
c     Complex Fast Fourier Transform
c
c     Coded by Y. OHSAKI in "Introduction to spectral analysis for
c                            seismic waves"
c     Typed by D.Suetsugu, IISEE
c     Modified by H.Inoue, IISEE
c
c     Usage.......   CALL FFT(N,X,IND)
c
c     where
c
c     X(N)    In/Out  Equi-spaced N complex data/Transformed values
c     N       In      Number of data, MUST be a power of 2.
c     IND     In      -1=Fourier transform,  1=Inverse Fourier transform
c
c     Note..... You must divide the output X() by N to get Fourier
c               coefficient when IND=-1.
c
c...........................................................................
      complex x(n),temp,theta
c
      j=1
      do 140 i=1,n
        if(i.ge.j) goto 110
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
  110   m=n/2
  120   if(j.le.m) goto 130
        j=j-m
        m=m/2
        if(m.ge.2) goto 120
  130   j=j+m
  140 continue
c  
      kmax=1
      do 150 kkk=1,9999
        if(kmax.ge.n) return
        istep=kmax*2
        do 170 k=1,kmax
          theta=cmplx(0.0,3.141593*float(ind*(k-1))/float(kmax))
          do 160 i=k,n,istep
            j=i+kmax
            temp=x(j)*cexp(theta)
            x(j)=x(i)-temp
            x(i)=x(i)+temp
  160     continue
  170   continue
        kmax=istep
  150 continue
      end
